#!"\xampp\perl\bin\perl.exe"
# configure Apache for current folder # Bookmarks: 0,0 0,0 0,0 0,0 0,0 0,0 0,0 0,0 0,0 0,26

use strict;
my ($t,@t,$f,$dpath,$wpath,$tpath,$spath,$hostname,$libpath,$pos,@files,$file,@l);

#get paths
$wpath="/xampp/web-gui";                        # does not work with perl cfg.pl
$dpath="$wpath/data";                        # path current working dir, use this   (=folder path/data)
print "wpath: $wpath\n";
print "dpath: $dpath\n";

$tpath="$wpath/tmp";
print "tpath: $tpath\n";

$spath="$dpath/cs_server";
print "spath: $spath\n";

$libpath="\"$dpath/cs_server/CGI\"";
print "libpath: $libpath\n";

$hostname=`hostname`;    chomp($hostname);
print "hostname: $hostname\n\n";

# Apache paths: httpd.conf and extra/httpd-ssl.conf with correct paths for apache.
&update_webserver;



sub update_perm {       # data/* read all, ./_log rw admin only
##########
        print "\n#######################\nset permissions\n";

}



#####################
sub update_webserver {
#####################
       # 1. set wwwroot and cgipath in apache httpd.conf
       $t="/xampp/apache/conf/httpd.conf";                 # update default apache file
       $t=~s/\//\\/g;                                      # use backslash

       #print "\nsetup $t\n------\n";
       $t=`type $t`;

       if (!($t=~/\w/))  { print "152 empty file $t\n"; exit; }
       @l=split(/\n/,$t);

       for (my $i=0;$i<@l;$i++) {
           if ($l[$i]=~/^DocumentRoot /)  {              # set DocumentRoot
               $l[$i]="DocumentRoot \"$dpath/wwwroot\"";
               $l[$i]=~s/\\/\//g;                        # slash not backslash
               #print "$l[$i]\n";

               $l[$i+1]="<Directory \"$dpath/wwwroot\">";
               $l[$i+1]=~s/\\/\//g;                      # slash not backslash
               #print "$l[$i+1]\n";
           }

           # <Directory "/xampp/web-gui/data/wwwroot/cgi-bin">
           if (($l[$i]=~/^<Directory /) && ($l[$i]=~/wwwroot.cgi\-bin/)) {
              $l[$i]="<Directory \"$dpath/wwwroot/cgi-bin\">";
              $l[$i]=~s/\\/\//g;                                             # slash not backslash
              #print "$l[$i]\n"
           }

           # script alias
           #    ScriptAlias /cgi-bin/ "/xampp/web-gui/data/wwwroot/cgi-bin/"
           if ($l[$i]=~/^ +ScriptAlias \/cgi\-bin\/ /)  {                    # set DocumentRoot
               $l[$i]="    ScriptAlias /cgi-bin/ \"$dpath/wwwroot/cgi-bin/\"";
               $l[$i]=~s/\\/\//g;                                            # slash not backslash
               #print "$l[$i]\n";
           }
       }

       # copy to \xampp\apache\conf\httpd.conf
       $t=join("\n",@l);

       print "update \\xampp\\apache\\conf\\httpd.conf\n";
       open(FH,'>\\xampp\\apache\\conf\\httpd.conf') or die $!;
         print FH $t;
       close(FH);

       ########################
       # 2. set wwwroot and cgipath in apache httpd-ssl.conf
       $t="/xampp/apache/conf/extra/httpd-ssl.conf";
       $t=~s/\//\\/g;
       $t=`type $t`;                         # use backslash

       if (!($t=~/\w/))  { print "204 empty file\n"; exit; }

       @l=split(/\n/,$t);

       for (my $i=0;$i<@l;$i++) {
           if ($l[$i]=~/^DocumentRoot /)  {              # set DocumentRoot
               $l[$i]="DocumentRoot \"$dpath/wwwroot\"";
               $l[$i]=~s/\\/\//g;                        # slash not backslash
               print "$l[$i]\n";
           }

       }

       # copy to \xampp\apache\conf\\extra\httpd-ssl.conf
       $t=join("\n",@l);

       print "update \\xampp\\apache\\conf\\extra\\httpd-ssl.conf\n";
       open(FH,'>\\xampp\\apache\\conf\\extra\\httpd-ssl.conf') or die $!;
         print FH $t;
       close(FH);
}


##
1;