#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

my ($out, $var,$k,$w,$p);  # declare all your variables as local or you will get errors

  # menue actions
  ###############

 #Windows pools
 if (!($current{'on'}=~/mswin/i))  {

      &mess('Windows Storage Pools and Storage Spaces is available on Windows only');

 } else {

    &load_lib('get-spaces.pl');

    print "<b>Windows Storage Pools</b>";
    $w="<b>Pool</b>\t<b>Operational</b>\t<b>Health</b>\t<b>Primordial</b>\t<b>Readonly</b>\t<b>Size</b>\t<b>Alloc</b>\t<b>Physicaldisks</b>\n";

    my @pools=split(/\t/,$win{'allpools'});
    my ($d);
    foreach my $pool (@pools) {

        # FriendlyName
        $k="p:$pool\_FriendlyName";
        $w.="$win{$k}\t";

        # OperationalStatus
        $k="p:$pool\_OperationalStatus";
        $w.="$win{$k}\t";

        # HealthStatus
        $k="p:$pool\_HealthStatus";
        $w.="$win{$k}\t";

        # IsPrimordial
        $k="p:$pool\_IsPrimordial";
        $w.="$win{$k}\t";

        # IsReadOnly
        $k="p:$pool\_IsReadOnly";
        $w.="$win{$k}\t";

        # Size
        $k="p:$pool\_Size";
        $w.="$win{$k}\t";

        # AllocatedSize
        $k="p:$pool\_AllocatedSize";
        $w.="$win{$k}\t";

        # get disks of pool
        $t=$pool; $t=~s/p://;
        $d=&exe("Get-PhysicalDisk -StoragePool (Get-StoragePool -FriendlyName \"$t\") | ft deviceid");
        chomp($d);
        $d=~s/\n*deviceid\n*//is;
        $d=~s/\-+\n*//is;
        $d=~s/\n/,/gs;
        $w.="$d\t";

        $w.="\n";

    }

    print &list2table($w);


   print "<br><br><b>Disks per Pool</b><br>";
   foreach my $pool (@pools) {
     $p=$pool; $p=~s/p://;
     if ($p eq "Primordial") { next; }
     $t=&exe("Get-StoragePool $p | Get-PhysicalDisk");
     print "Get-StoragePool $p | Get-PhysicalDisk<hr>";
     print "<pre><b>$pool</b>\n$t</pre><br>";
   }

   print "<br><br><b>Tiers per Pool</b><br>";
   #tiers
   foreach my $pool (@pools) {
     $p=$pool; $p=~s/p://;
     if ($p eq "Primordial") { next; }
     $t=&exe("Get-StoragePool $p | Get-Storagetier");
     if ($t=~/\w/s) {
       print "Get-StoragePool $p | Get-Storagetier<hr>";
       print "<pre><b>$pool</b>\n$t</pre><br>";
     }  else {
       print "Get-StoragePool $p | Get-Storagetier<hr>none<br>";
     }
   }


 } #/Windows

 print "<script language='javascript'>\$('#hl').html('Storage Pools on $in{'member'}\:$current{'on'}')</script>\n";
 &log_end;

 if ($log_on) {  print '<br><br>Hash %win<br>';   &print_hash(%win); }

}

###############################################
#end of my script, do not delete the line below
1;
