###############
sub my_action {
###############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action

 if ($current{'on'}=~/mswin/i) {
   &load_lib('get-spaces.pl');
 }  else {
   &mess('Storage Spaces are Windows only');
 }


  my ($var1, $ant, $type,$d);
#  &gethash_sys_poolnames;

# header
print "<script language='javascript'>document.getElementById('hl').innerHTML='create Windows Pool on $in{'member'}\:$current{'on'}'</script>\n";


# 1. edited
if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
if ($in{'answered'}) { &my_create; }     # form -> create

# 2. are the unused hds?
if ($disk{'all_unused'} eq "") {
  print" no disks available!";
  return;
}


# 2. get form
####################################################################
# create new pool

print <<EoF;
<b>Howto create a Windows Software Raid</b><br><pre>You can use Diskmanagement to create a diskbased raid under Windows or you can create a Windows Storagepool with Storage Spaces (virtual disks)
to manage storage as a pooling alternative to ZFS. While not as feature rich as ZFS, it can be good extension for some use cases ex when you need a higher disk performance as ZFS can offer.
Windows redundancy on storage pools is not based on disk redundancy like a traditional Raid but dataslab allocation of Storage Spaces/virtual disks. The space allocation is distributed proportionally
according to disk sizesand wanted redundancy level. This means that in a first step, vou just create a Storage Pool from one or more disks without defining redundancy. As storage Spaces can be
thin provisioned, initial Poolsize can be larger than available disks.

1. Define a Storage Pool in Windows Settings:
Open Windows Settings, select System > Storage > Advanced Storage Settings > Storage Spaces and create a new storage pool from available disks.
Size can be larger than disks. To delete a Storage Pool, just delete the included Storage Spaces. You can also define Storagepool here.

2. Create Storage Spaces (virtual disks).
On a storage pool you can create Storage Spaces with a certain size, striping and redundancy level. A Storage Space behaves basically like a disk but as it is a virtual disk
it can be thin provisioned and size can be changed. Redundany or distribution/striping of a Storage Space is not related to the underlying pool but can be set per Storage Space. Only restriction is
that a certain redundancy or stripe level ex dual parity or a raid-10 alike configuration can only be set when the minimum number of disks for such a Space is available.

3. Partitions
You can use, split or reduce size of a Storage Space and format with a filesystem like fat32, ntfs or ReFS and an individual Allocation setting that affects performance and space efficiency.

<b style='color:red'>Do not select disks you want to use by ZFS for a Windows Storage Pool<br>Check Disk Management. Disks must be empty and not contain a GPT Partition. You can clean disks with diskpart!!!</b></pre>
EoF


# form begin
  &ask('begin');

 ## how many disks
 @t=split(/\t/,$disk{'all_unused'});


## name of pool
  &ask('value_new','New pool name',"$in{'value_new'}",'30');
  ask('select_media','Mediatype when unspecified',"HDD,SSD,SCM,Unspecified");
  &ask('value_opt','Optional settings for NewStoragePool </b><br>-property value<b>',"$in{'value_opt'}",'w300');
  #&ask('value_size','Max Pool Size<br></b>can be larger than current overall disk capacity<b>',"$in{'value_size'}",'w37m3');
  #&ask('select_cap','Size in',"MB,GB,TB,PB,EX",'GB');
  #&ask('select_thin','Space Provisioning<br></b>Fixed with current capacity is faster, thin allows a dynamic grow<b>',"Thin,Fixed",'');

  ## checkboxes unused disks
  &ask('checkbox_hd','Disks (Add or remove disks later as poolmember or hotspare)<br></b>care about minimal disknumbers for wanted redundancy levels',$disk{'all_unused'})

&ask('end');
print "<script language='javascript'>\$('#hl').html('Create StoragePool on $in{'member'}\:$current{'on'}')</script>\n";

######################### / form ############################################

} #/ my_action
################



##############################################################################
sub my_create {
################ create pool

   my ($i,@w,$n,$what,$pool,$ver,$opt,$opt1,$children,$draid);

   print "after error messages or warnings, check menu pools for real pool state<br>";

   #name of pool
   $in{'value_new'}=&alltrim($in{'value_new'});            # remove  + spaces +

   # Strict
   $in{'value_new'}=~s/[^a-zA-Z0-9_\.\-]/_/g;              # allowed in poolnam are legal on opensolaris snv134 at least. Perhaps error checking should be left to the
   # command(?)

   #name??
   if ($in{'value_new'} eq "")    { &mess("missing poolname?"); }
   $in{'value_new'}=lc($in{'value_new'});


   # check if pool exists
   $r=&exe("get-storagepool | ft FriendlyName");
   if ($r=~/\b$in{'value_new'}\b/is)    { &mess("Storage Pool exists, choose another name?"); }

   #get hd-id
   $in{'checkbox_hd'}=~s/[^a-zA-Z0-9\-\_\,\.\+]//gs;        # remove special char from reload
   $in{'checkbox_hd'}=~s/\.\+$//;
   @w = split(/\.\+/,$in{'checkbox_hd'});                   # array of selected disks

   $n=@w;
   if ($n < 1)  { &mess("missing disks"); }

#&print_array(@w);

   # we need a list of uniqueid from physicaldrive0_UniqueId
   # 5000C5002DFAB4EE;50014E6EADFAE1EF;50014E6E58A5BD05

   $n="";
   foreach my $w (@w) {
     $t=$w."_UniqueId";
     $n.=";$disk{$t}";
   }
   $n=~s/^;+//;

# &mess($n);

   #create pool
   ################################################################
   # New-StoragePool -FriendlyName Pool-F -StorageSubSystemFriendlyName "Windows Storage*" -PhysicalDisks (Get-PhysicalDisk | ?{"5000C5002DFAB4EE;50014E6EADFAE1EF;50014E6E58A5BD05".Contains($_.uniqueid)})
   ###

   #action
   #######

   my $cmd=<<EoF;
New-StoragePool -FriendlyName $in{'value_new'} -StorageSubsystemFriendlyName "Windows Storage*" -PhysicalDisks (Get-PhysicalDisk | \?{"$n".Contains(\$_.uniqueid)}) $in{'value_opt'}
EoF

   $cmd=~s/\n//gs;
#&print_var("$cmd");
   print "$cmd<hr>";
   $i=&exe("$cmd");

   # set mediatype when not specivied
   # Get-StoragePool wpool | Get-PhysicalDisk | ? MediaType -eq "Unspecified" | Set-PhysicalDisk -MediaType SCM

   if ($in{'select_media'} ne "Unspecified")  {
     $cmd="Get-StoragePool $in{'value_new'} | Get-PhysicalDisk | ? MediaType -eq \"Unspecified\" | Set-PhysicalDisk -MediaType $in{'select_media'}";
     print "$cmd<br>";
     $i.=&exe("$cmd");
   }

   #something wrong?
   if ($i ne "") { print "$i"; sleep(3);  }

   # goto create spaces
   print "You can now create Storage Spaces (Virtual Disks)<br>";

   $t=&exe("Get-StoragePool $in{'value_new'} | Get-PhysicalDisk");
   print "<pre>$t</pre>";
   sleep(3);


   #$in{'l1'}="07_Filesystems";
   $in{'l2'}="12_Windows_Storagepool";
   $in{'l3'}="";
   &reload;

   exit;

   #################################

}





###############################################
#end of my script, do not delete the line below
1;