############
sub my_action {
############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools };                   # create this function in a private mylib.pl to replace this action


 ##
 my ($r,$ant,$prod,$w,$k);

 print <<EoF;
  <br>
  <a href="#" onclick="\$('.info').toggle();"><img src="/_doc/menu/ico/i16.png">Windows and ZFS Pools</a>
  <div class='info'><b>ZFS Pools</b><br><br>$txt{'pools_info'}

<b>Windows Storagepool</b>

A Windows Storage pool is not a Raid over disks but simply a bunch of disks. Capacity of such a pool can be greater than disk capacity
when you use thin provisioning. When you need the space, you can add disks later.

On such a Pool, you can creeate Storage Spaces (=virtual disks). In this step you can decide if you want redundancy. Redundancy is created by data
copies over several disks in a pool. This means that you can optimize for performance or security for every virtual disk indepenently.

As there is no diskbased Raid, you can add disks at any time to a pool without Raid transformation. A faulted disk must not be replaced with
a Raid rebuild, just removed. To rebalance data, you can use "optimize" in Windos Storage Spaces settings.
  </div><br><br>

EoF

  #zfs pools
  print "<b>ZFS Pools</b>";
  if (!($in{'prop'}=~/pooldetails/)) {
     &zfslib_pool_overview;
  }  else {
     &zfslib_pool_details;
  }


 #Windows pools
 if ($current{'on'}=~/mswin/i)  {
    &load_lib('get-spaces.pl');
    print "<br>";

    print "<b>Windows Storage Pools</b>";
    $w="<b>Pool</b>\t<b>Operational</b>\t<b>Health</b>\t<b>Primordial</b>\t<b>Readonly</b>\t<b>Size</b>\t<b>Alloc</b>\n";

    my @pools=split(/\t/,$win{'allpools'});
    foreach my $pool (@pools) {

        # FriendlyName
        $k="p:$pool\_FriendlyName";
        $w.="$win{$k}\t";

        # OperationalStatus
        $k="p:$pool\_OperationalStatus";
        $w.="$win{$k}\t";

        # HealthStatus
        $k="p:$pool\_HealthStatus";
        $w.="$win{$k}\t";

        # IsPrimordial
        $k="p:$pool\_IsPrimordial";
        $w.="$win{$k}\t";

        # IsReadOnly
        $k="p:$pool\_IsReadOnly";
        $w.="$win{$k}\t";

        # Size
        $k="p:$pool\_Size";
        $w.="$win{$k}\t";

        # AllocatedSize
        $k="p:$pool\_AllocatedSize";
        $w.="$win{$k}\t";

        # get disks of pool
        $t=$pool; $t=~s/p://;
        $d=&exe("Get-PhysicalDisk -StoragePool (Get-StoragePool -FriendlyName \"$t\") | ft deviceid");
        chomp($d);
        $d=~s/\n*deviceid\n*//is;
        $d=~s/\-+\n*//is;
        $d=~s/\n/,/gs;
        $w.="$d\t";

        $w.="\n";

    }

    print &list2table($w,"100%,80px");

 }


  #status with disk cap and  model
    $ant.=&exe("zpool status");
    if (!($ant=~/pool/is)) {
      $ant="no pool found, create or import one";
    }
    my @l=split(/\n/,$ant);
    my ($s,$t,$k,$id,$pool);

    if ($cfg{'select_lang'}=~/my|app/i) {
         $prod="Product /Disks";
    } else {
         $prod="Product /napp-it";
    }
    if ($txt{'app_about_pools_product'} =~/\w+/) {
         $prod=$txt{'app_about_pools_product'};
    }
    $prod.=" " x16;
    $prod=substr($prod,0,16);

    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/^ +NAME/) { $l.="      CAP            $prod   SN/LUN           IOstat mess       SMART"; }
        if ($l=~/pool:/) { $pool=$l; $pool=~s/pool://; $pool=~s/\s+//; }

       if ($l=~/dedup/) {
                  $t="$pool\_dedup_size2";
                  $l.="vdev"." " x 13;
                  $l.=$zfs{$t};

                  $t="$pool\_dedup_used";
                  if ($zfs{$t} > 79) {
                     $l.="<font style='color:red'>   used: $zfs{$t}</font>";
                  } else {
                     $l.="<font style='color:blue'>   used: $zfs{$t}</font>";
                  }
                  $t="$pool\_dedupratio";
                  $l.="  dedupratio: $zfs{$t}";
                  #&print_var("$l");
        }  # dedup

        if ($l=~/special/) {
                  $t="$pool\_special_size2";
                  $l.="vdev"." " x 13;
                  $l.=$zfs{$t};

                  $t="$pool\_special_used";
                  if ($zfs{$t} > 79) {
                     $l.="<font style='color:red'>   used: $zfs{$t}</font>";
                  } else {
                     $l.="<font style='color:blue'>   used: $zfs{$t}</font>";
                  }

                  #&print_var("$l");
        }  # special

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd|lofi|^phys/) {      # is disk Solaris or Linux or Win
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices

             $id=$t;

             $k="$id"."_Size";
             $k=~s/p\d//;                        #sizet
             $s=$disk{$k}." " x 15;
             $s=substr($s,0,16);
             $l.="      $s";

             $k="$id"."_Manufacturer";                #
             $s=15-length($disk{$k});
             $l.="      $disk{$k}"." "x $s;


             $k="$id"."_Model";
             $k=~s/p\d//;                        #disk not part
             $s=$disk{$k}." " x 35;
             $s=substr($s,0,16);
             $l.=$s;

             $l.="   ";

             # add sn/lun
             if ($current{'on'}=~/mswin/i) {
                $k="$id"."_Serialnumber";
             } else {
                $k="$id"."_Serial_No";
             }
             $k=~s/p\d//;                        #sn=lun

             $t="sn $disk{$k}"." "x20;
             $t=substr($t,0,16);
             $l.=$t;

             # add iostat
             $k="$id"."_error";
             $k=~s/p\d//;                        #iostat err

             @t=();
             $t=$disk{$k};
             $t=~s/.://g;
             @t=split(/ /,$t);
             $t=$disk{$k}."      ";
             $t=substr($t,0,18);

             if (($t[1] > 9) || ($t[2] > 9))   {
               $t="<font style='color:blue; font-size: 11px'>$t</font>";   # T:/H: values > 9
             }

             if ($l=~/lofi/) {
                  $k="$id";
                  $t="$disk{$k}";

                  $k="$id"."_options";
                  $t.="  $disk{$k}";
             }
             $l.=$t;

             # add SMART if avail per acc
             $k="$id"."_smart_overview2";
             if ($disk{$k} eq "") { $disk{$k}="-"; }
             $l.=" ".$disk{$k};

        }

    }

    $ant=join("\n",@l);
    $ant=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $ant=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $ant=~s/REMOVED/<font style='color:red'>REMOVED<\/font>/igs;
    $ant=~s/OFFLINE/<font style='color:red'>OFFLINE<\/font>/igs;
    $ant=~s/\bAVAIL/<font style='color:blue'>AVAIL<\/font>/gs;
    $ant=~s/INUSE/<font style='color:blue'>INUSE<\/font>/gs;
    $ant=~s/DEGRADED/<font style='color:blue'>DEGRADED<\/font>/gs;
    $ant=~s/replacing/<font style='color:blue'>replacing<\/font>/gs;


    print "<br><br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";

    # header
    print "<script language='javascript'>\$('#hl').html('Pools on $in{'member'}\:$current{'on'}')</script>\n";


}



#EoF ######################
# do not remove line below (return true)
1;