#!

###############
sub my_action {
###############

 # shrink pool/ remove vdev
 #override with private functions?
 ##################################
 eval { &mylib_menue_snaps_system };                   # create this function in a private mylib.pl to replace this action

 my ($var1, $ant, $pools, @pools, $cp, $type, $d, $r, $v, @v);

 #create url
 my $url_c="<a style='font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;pool==p=\&amp;action=create\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;member=$in{'member'}\" onclick=\"return(confirm('create checkpoint for pool =p= ?'))\">create</a>";

 # destroy url
 my $url_d="<a style='font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;pool==p=\&amp;action=destroy\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;member=$in{'member'}\" onclick=\"return(confirm('destroy checkpoint for pool =p= ?'))\">destroy</a>";

# header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='Poolwide Checkpoints'</script>\n";
    print "<b>Poolwide checkpoint state</b><br><br>";

# check if functionality is available
$r=&exe("zpool checkpoint");   # returns cannot determine size (ok)
                               # cannot open '-n' (featute not supported)
#&mess($r);
if (!($r=~/pool argument/s)) {
  print <<EoF;
  <pre>
  CP is a feature in Open-ZFS.
  Your OS does not support this feature.</pre>
EoF
  &log_end;
  exit;
}

if ($in{'action'}=~/create|destroy/) {
  &my_cp;
}

# 2. pool state
# pools (rpool first)
$pools="rpool"."\t$zfs{'datapools'}";
@pools=split(/\t/,$pools);

# table
$t="<img src='/_doc/space.gif' style='width:250px;height:1px'>";
$ant="<b>Pool</b>\t<b>Checkpoint state</b>$t\t<b>Create CP</b>\t<b>Destroy CP</b>\n";

foreach my $p (@pools) {
   # poolname
   $ant.="$p";

   # status
   $r=&exe("zpool status $p");
   if ($r=~/checkpoint: /s) {
     $cp="1";
     @v=();
     @v=split(/\n/,$r);
     foreach my $v (@v) {
         if ($v=~/checkpoint: /) {
           $ant.="\t$v";
         }
     }
   } else {
     $ant.="\tnone";
     $cp="0";
   }

   # create
   if ($cp) {
      $ant.="\t\t$url_d";    # destroy
   } else {
      $ant.="\t$url_c\t";    # create
   }
   $ant=~s/=p=/$p/gs;

   # next
   $ant.="\n";
}

print &list2table($ant);

# message
print <<EoF;
<br><br><b>Limitations</b><pre>zpool checkpoint [-d, --discard] pool
   Checkpoints the current state of pool, which can be later restored by zpool import --rewind-to-checkpoint.
   The existence of a checkpoint in a pool prohibits the following zpool commands:

   - remove, attach, detach, split, and reguid.  In addition, it may break reservation boundaries if the pool lacks
     free space. The zpool status command indicates the existence of a checkpoint or the progress of discarding
     a checkpoint from a pool. The zpool list command reports how much space the checkpoint takes from the  pool.
   - <font style='color:red'>you may not be able to import such a pool on older systems without this feature</font>
</pre>
EoF


# bottom
&my_pools;

print "<script language='javascript'>document.getElementById('hl').innerHTML='System Checkpoints on $in{'member'}\:$current{'on'}'</script>\n";



} #/ my_action
################


#########
sub my_pools {
#########
#status with disk cap and  model
    print "<br>";
    my $ant=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="     CAP            Product";}

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices
             $k="$t"."_partcap";
             $s=15-length($disk{$k});

             $l.="     $disk{$k}"." "x $s;
             $k="$t"."_product";
             $k=~s/p\d//;                        #disk not part
             $l.=$disk{$k};
        }

    }
    $ant=join("\n",@l);
    $ant=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $ant=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $ant=~s/REMOVED/<font style='color:red'>removed<\/font>/igs;
    $ant=~s/\bAVAIL/<font style='color:blue'>AVAIL<\/font>/gs;
    $ant=~s/INUSE/<font style='color:blue'>INUSE<\/font>/gs;
    $ant=~s/DEGRADED/<font style='color:blue'>DEGRADED<\/font>/gs;


    print "<br><br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";
}

##############################################################################
sub my_cp {
################
   #&print_hash(%in);

    if ($in{'action'} eq "create") {
         print &exe("zpool checkpoint $in{'pool'}");
    }

    if ($in{'action'} eq "destroy") {
         print &exe("zpool checkpoint -d $in{'pool'}");
    }
    sleep(4);
}





###############################################
#end of my script, do not delete the line below
1;
