#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

my ($out,$r,$options);  # declare all your variables as local or you will get errors

# menue actions
###############

print <<EoF;
<b>SMB Direct/RDMA</b><br>
is a method to increase network performance massively with a reduced cpu load. <br>RDMA requires a Windows Server edition as SMB server and RDMA capable nics<br><br>
see <a href="https://learn.microsoft.com/en-us/windows-server/storage/file-server/smb-direct?tabs=enable#disabling-and-enabling-smb-direct-features" target='_blank'>SMB Direct Help</a>
<br><br>
EoF

print "<script language='javascript'>document.getElementById('hl').innerHTML='Your OS is $current{'on'} on $current{'member_ip'}'</script>\n";
&log_end;

if (!($current{'on'}=~/mswin/i)) {
   print "Your OS is $current{'on'} on $current{'member_ip'}<br>This menu is for Windows";   exit;
}

$options=<<EoF;
-,
01 Get SMB Shares,
02 Get SMB Server Nic settings,
03 Get SMB Client Nic settings,
04 Get State SMB Direct,
05 Enable SMB Direct,
06 Disable SMB Direct
EoF

$options=~s/\n//gs;             # commalist

# 01 get-smbshare
# 02 get-SmbServerNetworkInterface
# 03 get-SmbClientNetworkInterface
# 04 Get-WindowsOptionalFeature -Online -FeatureName SMBDirect
# 05 Enable-WindowsOptionalFeature -Online -FeatureName SMBDirect
# 06 Disable-WindowsOptionalFeature -Online -FeatureName SMBDirect

#

&ask('begin');
&ask('autoselect','Select option',$options,$in{'autoselect'});

&ask('hidden','changed','1');
&ask('end');

if ($in{'autoselect'} eq "") { $in{'autoselect'}= "01 Get SMB Shares"; }

if ($in{'autoselect'}=~/01/) { $r=&exe("get-smbshare"); }
if ($in{'autoselect'}=~/02/) { $r=&exe("get-SmbServerNetworkInterface"); }
if ($in{'autoselect'}=~/03/) { $r=&exe("get-SmbClientNetworkInterface"); }
if ($in{'autoselect'}=~/04/) { $r=&exe("Get-WindowsOptionalFeature -Online -FeatureName SMBDirect"); }
if ($in{'autoselect'}=~/05/) { $r=&exe("Enable-WindowsOptionalFeature -Online -FeatureName SMBDirect"); }
if ($in{'autoselect'}=~/06/) { $r=&exe("Disable-WindowsOptionalFeature -Online -FeatureName SMBDirect"); }

print "<br><b>Result of $in{'autoselect'}</b><hr>\n<pre>$r</pre>";



} #/ my_action





###############################################
#end of my script, do not delete the line below
1;