#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

my ($out,$r,$var,$k,$w,@p,$cluster,$cm,$fp);  # declare all your variables as local or you will get errors

# we need hyper-v powershell modules:

print <<EoF;
<a href="#" onclick="\$('.info').toggle();"><img src="/_doc/menu/ico/i16.png"> (Howto setup virtual disk support)</a><br><br>

<div class='info'><b>Virtual Diskimages</b>

<b>Virtual Diskimge management in Windows Powershell</b> is included in Hyper-V and not installed per default.
To install eg in Windows 11 Pro:

Press the Windows key + R to open the Run dialog box.
Type appwiz.cpl and press Enter.
In the Programs and Features window, select Turn Windows features on or off in the left-hand pane.
In the Windows Features window, scroll down to Hyper-V and check the box next to it.

install hyper-v services (needed).
install hyper-v hypervisor (optional).

install hyper-v gui (optional)
install hyper-v moduls for powershell (needed).

Without the hyper-v services and Powershell modules, you can create or enable virtual disk images in Windows Diskmanagement.


<b>Virtual diskimages</b> (*.vhdx/vhd/iso)
are files that you can use like physical disks. This is perfect for testing Storage Spaces or ZFS features with many disks.
Diskimages can be placed on lokal disks or Storage Spaces or remote on SMB shares. To allow auto discovery, place all local vhdx files
in c:\vhdx or v:\vhdx  to allow. Virtual diskimages to build a network Cluster over an SMB share should be in an SMB share named vhdx
with cs_cluster.vhdx as name ex \\102.168.1.10\vhdx\cs_cluster.vhdx.. Add "auto" to name to automount the virtual harddisk on bootup. </div>
EoF

#mount image
#>Mount-DiskImage -ImagePath "E:\xx.vhd1"

#get remote files
#Get-ChildItem -Path \\192.168.2.203\napp-it\* -Filter *.vhd*

#lokal
#Get-ChildItem -Path C:\Users\<Benutzername>\Dokumente

#lokal
#Get-ChildItem -Path C:\Users\<Benutzername>\Dokumente

#Get-physicaldisk

#Number FriendlyName                 SerialNumber         MediaType   CanPool OperationalStatus HealthStatus Usage
#------ ------------                 ------------         ---------   ------- ----------------- ------------ -----
#10     SUN COMSTAR SCSI Disk Device                      Unspecified False   OK                Healthy      Auto-Se...
#6      SUN COMSTAR                                       Unspecified False   OK                Healthy      Auto-Se...
#12     Msft Virtual Disk                                 Unspecified False   OK                Healthy      Auto-Se...
##############

# Msft
##############
#Get-DiskImage -DevicePath \\.\PHYSICALDRIVE12

#Attached          : True
#BlockSize         : 0
#DevicePath        : \\.\PhysicalDrive12
#FileSize          : 1073742336
#ImagePath         : \\192.168.2.203\napp-it\vhdn.vhd
#LogicalSectorSize : 512
#Number            : 12
#Size              : 1073741824
#StorageType       : 2
#PSComputerName    :

#mount
#PS C:\>Mount-DiskImage -ImagePath "E:\ISO-Files\My US Visit Fall 2010 Pictures.iso"

#dismount
#PS C:\>Dismount-DiskImage -ImagePath "E:\ISO-Files\My US Visit Fall 2010 Pictures.iso"
#PS C:\>Dismount-DiskImage -DevicePath \\.\CDROM1

#Windows ?
if (!($current{'on'}=~/mswin/i))  {

      &mess('Windows Storage Pools, Storage Spaces, vhdx images and support for a ZFS Cluster over SMB is available on Windows only');

} else {

    #&load_lib('get-spaces.pl');        # needed? costs time
}

#&print_hash(%in);
if ($in{'action'} eq "connect_vhd")    { &connect_vhd;  }
if ($in{'action'} eq "disconnect_vhd") { &disconnect_vhd; }
if ($in{'action'} eq "create_vhd")     { &create_vhd; }

&my_get_vhd("c:/vhdx");                 # local c
&my_get_vhd("v:/vhdx");                 # local v

#########################################

$current{'form'}=<<EoF;
   <form name='filter1' method='post' action='/cgi-bin/admin.pl'>
   <input type='hidden' name='member' value="$in{'member'}">
   <input type='hidden' name='id' value="$in{'id'}">
   <input type='hidden' name='l1' value="$in{'l1'}">
   <input type='hidden' name='l2' value="$in{'l2'}">
   <input type='hidden' name='l3' value="$in{'l3'}">
EoF

$current{'enablebutton'}  ="<button type='submit' name='action' value='connect_vhd' title='Connect vhd' style='margin:3px 0 5px 0;text-align:left' onclick=\"if (confirm('Connect selected vhd?')) { return true; } else { return false; }\"><img src='\/_doc\/connect.png' style='margin-top:3px'></button>";
$current{'disablebutton'} ="<button type='submit' name='action' value='disconnect_vhd' title='Disconnect vhd' style='margin:3px 0 5px 0;text-align:left' onclick=\"if (confirm('disconnect selected?')) { return true; } else { return false; }\"><img src='\/_doc\/disconnect.png' style='margin-top:3px'></button>";
$current{'createbutton'} ="<button type='submit' name='action' value='create_vhd' title='Create vhd' style='margin:3px 0 5px 0;text-align:left' onclick=\"if (confirm('create vhd?')) { return true; } else { return false; }\"><img src='\/_doc\/create.png' style='margin-top:3px'></button>";

$current{'check_enable'}="<input style='width:13px; height:13px;margin:1px' type='checkbox' name=\"connect\" value=\"=vhd=.+\">";
$current{'check_disable'}="<input style='width:13px; height:13px;margin:1px' type='checkbox' name=\"disconnect\" value=\"=vhd=.+\">";

#                table  loc  name  nr   cp  conn  dis for type  id      fs siz   min log  phys
$current{'tdw'}="100%,180px,185px,35px,40px,65px,60px,70px,80px,220px,60px,60px,60px,60px,60px";       # list2table
##########################################
 print $current{'form'};

 ################################################################################
 print "<br><b>Local Windows Diskimages (must be in c:\\vhdx or v:\\vhdx) and are automounted with 'auto' in name.</b>";
 ################################################################################

 $w="Member\tDiskimage\tPhNr\tCanpool\tConnect\tDisconnect\tFormat\tType\tDiskIdentifier\tFilesize\tSize\tMinsize\tLogical\tPhysical\tAlign\tBlocksize\tFrag\t\n\n";

 my @vd=split(/\t/,$win{'all_vhd'});

 if (@vd==0) { $w.="none"; }
 @vd=sort(@vd);

 #&print_array(@vd);
 foreach my $vd (@vd) {

        # skip clusterdisks
        if ($vd=~/cs\_cluster\.vhd/) { next; }

        # Member
        $w.="$current{'member_hostname'}\~$current{'member_ip'}\t";

        # Path
        $k=$vd."_Path";
        $fp=$win{$k};                      # filepath

        $t=$win{$k}; $t=~s/\//\\/g;
        $w.="$t\t";

        # clusterimage on localhost?
        if ($win{$k}=~/cs\cluster\.vhd/) {
           $cluster="1";
        }

        # Number
        $k=$vd."_Number";
        $w.="$win{$k}\t";

        #canpool
        if ($win{$k}>0) {
           $t="physicaldrive$win{$k}\_CanPool";
           $w.="$disk{$t}\t";
        } else {
           $w.="-\t";
        }

         # Connect and Disconnect
        if ($win{$k}=~/\d/) {    # connected
            $w.="ok\t$current{'check_disable'}\t";
        } else {
            $w.="$current{'check_enable'}\tnc\t";
        }
        $w=~s/=vhd=/$fp/g;

        # VhdFormat
        $k=$vd."_VhdFormat";
        $w.="$win{$k}\t";

        # Type
        $k=$vd."_VhdType";
        $w.="$win{$k}\t";

        # DiskIdentifier
        $k=$vd."_DiskIdentifier";
        $w.="$win{$k}\t";

        # FileSize
        $k=$vd."_FileSize";
        $w.="$win{$k}\t";

        # Size
        $k=$vd."_Size";
        $w.="$win{$k}\t";

        # MinimumSize
        $k=$vd."_MinimumSize";
        $w.="$win{$k}\t";

        # LogicalSectorSize
        $k=$vd."_LogicalSectorSize";
        $w.="$win{$k}\t";

        # PhysicalSectorSize
        $k=$vd."_PhysicalSectorSize";
        $w.="$win{$k}\t";

        # Alignment
        $k=$vd."_Alignment";
        $w.="$win{$k}\t";

        # BlockSize
        $k=$vd."_BlockSize";
        $w.="$win{$k}\t";

        # FragmentationPercentage
        $k=$vd."_FragmentationPercentage";
        $w.="$win{$k} %\t";
        if ($win{$k} ne "") { $w.=" %\t"; } else { $w.="\t"; }

        $w.="\n";
 }

 # mass connect/disconnect
 $w.="<br><b>Mass Action</b>\t\t\t\t$current{'enablebutton'}\t$current{'disablebutton'}\n\n";
 print &list2table($w,"$current{'tdw'}","bold");



 print "<br><br>Cluster Menmbernames beside localhost must start with cs_ ex cs_Proxmox1. <br>You can use such a Cluster for a network Node Redundancy setup for Storage Spaces or a ZFS pool.";
 print "<br>Diskimages for a SMB Network Cluster must be named cs_cluster.vhdx and accessable via SMB share \\\\hostip\\vhdx\\cs_cluster.vhdx<br>";
 print "Clusterdisks on a remote node must be created and initialized but not connected on a remote node locally. Connect the disk from Cluster master<br>";

 ################################################################################
 print "<br><b>Cluster Diskimages (must be \\\\ip\\vhdx\\cs_cluster.vhdx)</b>";
 ################################################################################
 if ($current{'members'}=~/\bcs\_/)   { $cluster="1"; }

 if ($cluster) {  $cm="$current{'members'}"; } else { $cm="none"; }


 $w="Clustermember\tDiskimage\tPhNr\t\CanPool\tConnect\tDisconnect\tFormat\tType\tDiskIdentifier\tFilesize\tSize\tMinsize\tLogical\tPhysical\tAlign\tBlocksize\tFrag\t\n\n";

 my @member=split(/\t/,$current{'members'});
 my ($vd,$format);

 #&print_array(@vd);
 foreach my $member (@member) {

        # Member
        if (!($member=~/localhost|none|\bcs\_/)) { next; } # not a smb cluster member

        $w.="$member\t";

        # ip and Path
        $t=$member; $t=~s/.*~//;    # ip only
        $w.="\\\\$t\\vhdx\\cs_cluster.vhdx\t";

        #get vhd infos
        $vd="//$t/vhdx/cs_cluster.vhdx";
        $fp=$vd;
        &my_get_vhd("$vd");

        #format
        $k=$vd."_VhdFormat";
        $format=$win{$k};

        # Number
        $k=$vd."_Number";
        $w.="$win{$k}\t";

        #canpool
        if ($win{$k}>0) {
           $t="physicaldrive$win{$k}\_CanPool";
           $w.="$disk{$t}\t";
        } else {
           $w.="-\t";
        }

        # Connect and Disconnect
        if (($win{$k}=~/\d/) || (!($format=~/vhd/i))) {    # connected  or n.a.
            if ($format=~/vhd/i) {
               $w.="ok\t$current{'check_disable'}\t";
            }  else {
               $w.="n.a.\t$current{'check_disable'}\t";
            }
        } else {
            $w.="$current{'check_enable'}\tnc\t";
        }
        $w=~s/=vhd=/$fp/g;

        # VhdFormat
        $k=$vd."_VhdFormat";
        $w.="$win{$k}\t";

        # Type
        $k=$vd."_VhdType";
        $w.="$win{$k}\t";

        # DiskIdentifier
        $k=$vd."_DiskIdentifier";
        $w.="$win{$k}\t";

        # FileSize
        $k=$vd."_FileSize";
        $w.="$win{$k}\t";

        # Size
        $k=$vd."_Size";
        $w.="$win{$k}\t";

        # MinimumSize
        $k=$vd."_MinimumSize";
        $w.="$win{$k}\t";

        # LogicalSectorSize
        $k=$vd."_LogicalSectorSize";
        $w.="$win{$k}\t";

        # PhysicalSectorSize
        $k=$vd."_PhysicalSectorSize";
        $w.="$win{$k}\t";

        # Alignment
        $k=$vd."_Alignment";
        $w.="$win{$k}\t";

        # BlockSize
        $k=$vd."_BlockSize";
        $w.="$win{$k}\t";

        # FragmentationPercentage
        $k=$vd."_FragmentationPercentage";
        $w.="$win{$k}";
        if ($win{$k} ne "") { $w.=" %\t"; } else { $w.="\t"; }

        $w.="\n";
 }

 # mass connect/disconnect
 $w.="<br><b>Mass Action</b>\t\t\t\t$current{'enablebutton'}\t$current{'disablebutton'}\n\n";
 print &list2table($w,"$current{'tdw'}","bold");


 ############### new diskimage  ###########
 print "<br><br>";
 print "<b>Create new filebased virtualdisk</b>";
 $w="Filepath (must exist)\tName ex vhd3.auto or cs_cluster\tPhNr\tCanPool\tConnect\tDisconnect\tFormat\tType\tDiskIdentifier\tFilesize\tSize\tMinsize\tLogical\tPhysical\tAlign\tBlocksize\tFrag\t\n\n";

 # add formelements
 #################

 # location
 @t=split(/\t/,$current{'members'});

 my $cs="\\\\localhost~127.0.0.1\\vhdx";                   # always
 foreach my $m (@t) {
    if ($m=~/^cs\_/)  { $cs.=",\\\\$m\\vhdx"; }
 }

 $t=&select('location',"c:\\vhdx,v:\\vhdx,$cs",'','','','','margin-top:1px'); $t=~s/\n|\t//gs;
 $w.="$t\t";

 # filename
 $w.="<input type='text' title='file name ex vhd3' name='filename' style='height:12px; width:150px;margin-top:1px'>\t.vhdx\t-\t-\t\tVHDX\t";

 #Type
 $t=&select('type',"Dynamic,Fixed",'','','','','margin-top:1px'); $t=~s/\n|\t//gs;
 $w.="$t\t";

 # action
 $t=&select('do',"create and initialize and connect,create and initialize,create only",'','','','','margin-top:1px'); $t=~s/\n|\t//gs;
 $w.="$t\t-\t";

 #Size
 $w.="<input type='text' title='Size max 65536 (GB), for Canpool = True min 10GB' name='size' style='height:12px; width:40px;margin-top:1px'>\t";

 #Units
 $t=&select('unit',"GB,MB,KB",'','','','','margin-top:1px'); $t=~s/\n|\t//gs;
 $w.="$t\t";

 #logical
 $t=&select('logical',"512,4096",'','','','','margin-top:1px'); $t=~s/\n|\t//gs;
 $w.="$t\t";

 # physical
 $t=&select('physical',"4096,512",'','','','','margin-top:1px'); $t=~s/\n|\t//gs;
 $w.="$t\t-\t";

 # create
 $w.="$current{'createbutton'}\t\t";
 print &list2table($w,"$current{'tdw'}","bold");
 print "<br><br>";

 print "</form>";

 print "<b>Destroy filebased virtualdisk</b><br>Disconnect and delete via Explorer";
 print "<br><br>";

 # header
  print "<script language='javascript'>\$('#hl').html('Virtual Harddisk Images on $in{'member'}\:$current{'on'} (Hyper-V Powershell extension must be enabled in appwiz.cpl)')</script>\n";
  &log_end;

 ############## / cluster ##################
 if ($log_on) {
    print "<br>Get-StorageJob<hr>";
    $r= &exe("Get-StorageJob");
    print "<pre>$r</pre>";
    &print_hash(%win);
 }


} #/ my_action


##################        # path
sub my_get_vhd   {
##################
    # get images from local path or smb share
    my ($p,@p,$r,@l,$vhd,$k,$ps,$ip);
    my $path=$_[0];                        # c:/vhd or v:/vhd or //ip/vhdx/cs_cluster.vhdx

    if ($path=~/c:|v:/) {
       $r=&exe("Test-Path -Path $path");
    } else {
       $r=&socket("Test-Path -Path $path","127.0.0.1");   # to detect localhost clusterfile
    }
    #print "<br>$path -> $r";

    if ($r=~/True/i) {

         $ps=$path."_status";
         $win{$ps}="online";

         # local
         if ($path=~/c:|v:/) {
            $r=&exe("Get-ChildItem -Path $path/*.vhd* | Select-Object -ExpandProperty Name");

         } else {
           $r=$path;  # //ip/vhd/ca_server.vhdx
         }

       if ($r=~/\.vhd/s) {

           @t=split(/\n/,$r);
           foreach my $t (@t)  {

             if (!($t=~/\.vhd/)) { next; }

             if ($path=~/c:|v:/) {           # local on member
                $vhd="$path/$t";
                $win{'all_vhd'}.="\t$vhd";
                $r=&exe("Get-VHD -Path $path/$t");

             } else {                        # clusterdisk from local view

                $vhd="$path";
                $win{'all_clvhd'}.="\t$path";
                $r=&socket("Get-VHD -Path $path","127.0.0.1");
#&mess($r);
             }

             # get details about

             # ComputerName            : MY-W11
             #Path                    : v:\vhdx\vhd1.vhd
             #VhdFormat               : VHD
             #VhdType                 : Fixed
             #FileSize                : 10737418752
             #Size                    : 10737418240
             #MinimumSize             : 10735337984
             #LogicalSectorSize       : 512
             #PhysicalSectorSize      : 512
             #BlockSize               : 0
             #ParentPath              :
             #DiskIdentifier          : 33A3382B-0DC7-4780-8BD5-744427975917
             #FragmentationPercentage : 0
             #Alignment               : 1
             #Attached                : False
             #DiskNumber              :
             #IsPMEMCompatible        : False
             #AddressAbstractionType  : None
             #Number                  :

             #vhdx
             #ComputerName            : MY-W11
             #Path                    : c:\vhdx\vhd3.vhdx
             #VhdFormat               : VHDX
             #VhdType                 : Dynamic
             #FileSize                : 4194304
             #Size                    : 1073741824
             #MinimumSize             :
             #LogicalSectorSize       : 512
             #PhysicalSectorSize      : 4096
             #BlockSize               : 33554432
             #ParentPath              :
             #DiskIdentifier          : 76879524-7F99-47DB-8D20-FF5336A4D00F
             #FragmentationPercentage : 0
             #Alignment               : 1
             #Attached                : False
             #DiskNumber              :
             #IsPMEMCompatible        : False
             #AddressAbstractionType  : None
             #Number                  :
             #

             #details
             @l=split(/\n/,$r);
             foreach my $l (@l)  {
                   if (!($l=~/:/)) { next; }
                   @p=split(/ *: */,$l);                        # prop:value

                   $k=$vhd."_$p[0]";
                   if ($p[0] eq "Path") { $p[1]=$vhd;  }        # use / in path to avoid masking, powershell is ok with /

                   $win{$k}=$p[1];
                   if ($p[0]=~/\bSize|\bFileSize|\bMinimumSize|\bBlocksize/i) {
                       $win{$k}=&b_convert($win{$k},'b','s');
                   }
             }

         } #foreach

         $win{'all_vhd'}=~s/^\t//;
         $win{'all_clvhd'}=~s/^\t//;

       }  #if vhd

    }   else {  # if path
      $ps=$path."_status";
      $win{$ps}="unavailable";
    }

}

###############
sub create_vhd {
##############
  # New-VHD -Path "D:\VHD\Example.vhdx" -Fixed -SizeBytes 1GB
  #New-VHD
  # [-Path] <String[]>
  # [-SizeBytes] <UInt64>
  # [-Dynamic]
  # [-BlockSizeBytes <UInt32>]
  # [-LogicalSectorSizeBytes <UInt32>]
  # [-PhysicalSectorSizeBytes <UInt32>]
  # [-AsJob]

  # New-VHD -Path c:/vhdx/2.vhd -SizeBytes 1GB -asjob |    Mount-VHD -Passthru |  Initialize-Disk -PassThru -asjob

  #path?
  if ($in{'location'}=~/~/) { $in{'location'}=~s/.*~/\\\\/; } # ip only
  print "Test-Path -Path $in{'location'}<br>";
  my $r=&exe("Test-Path -Path $in{'location'}");
  if ($r=~/false/i)  { &mess("Location $in{'location'} does not exist, please create first"); }

  # filename
  $in{'filename'}=lc($in{'filename'}); $in{'filename'}=~s/ +/_/g; 
  $in{'filename'}=~s/[^a-zA-Z0-9\-\_\.]//gs;

  if ($in{'filename'} eq "") { &mess("Please enter a valid filename ex vhd3 or cs_cluster"); }

  #exist?
  $r=&exe("Test-Path -Path $in{'location'}\\$in{'filename'}.vhdx");
  if ($r=~/true/i)  { &mess("File $in{'location'}\\$in{'filename'}.vhdx exists, please use another filename"); }

  #type?

  #size
  $in{'size'}=~s/\D//g;
  if (!($in{'size'} >0)) { &mess("Enter size > 0"); }
  if ($in{'size'} >65536) { &mess("Enter size <= 65536"); }
  $in{'size'}.=$in{'unit'};

  # create cmd on member
  my $cmd="New-VHD -Path \"$in{'location'}\\$in{'filename'}.vhdx\" -$in{'type'} -SizeBytes $in{'size'} -LogicalSectorSizeBytes $in{'logical'} -PhysicalSectorSizeBytes $in{'physical'} -Confirm:\$false";

  #connect
  if ($in{'do'}=~/connect/) {
    $cmd.=" |  Mount-VHD -Passthru ";
  }

  #initialize?
  if ($in{'do'}=~/initialize/) {
    $cmd.=" |  Initialize-Disk -PassThru -asjob";
  }

 #do
 $r= &exe("$cmd");
 print "$cmd<hr>$r";

 print "<br><br>Get-StorageJob<hr>";
 $r= &exe("Get-StorageJob");
 print "<pre>$r</pre>";
 sleep(5);
 #exit;
 $in{'action'}="";
 &reload;

}

###############
sub connect_vhd {
##############
   #mount
   #PS C:\>Mount-DiskImage -ImagePath "E:\ISO-Files\My US Visit Fall 2010 Pictures.iso"

   $in{'connect'}=~s/[^a-zA-Z0-9\\\/\-\_\.\+~:]//gs;
   my @vhd=split(/\.\+/,$in{'connect'});

   foreach my $v (@vhd) {
      $v=~s/\s//gs;
      print "Mount-DiskImage -ImagePath $v<br>";
      print &socket("Mount-DiskImage -ImagePath $v -AsJob","127.0.0.1");
      sleep(2);
      print "<br>";
   }

   sleep(2);
   $in{'action'}="";
   #exit;
   &reload;

   #&print_array(@vhd);
   #&print_hash(%in);
}

###############
sub disconnect_vhd {
##############

   #dismount
   #PS C:\>Dismount-DiskImage -ImagePath "E:\ISO-Files\My US Visit Fall 2010 Pictures.iso"
   #PS C:\>Dismount-DiskImage -DevicePath \\.\CDROM1

   $in{'disconnect'}=~s/[^a-zA-Z0-9\\\/\-\_\.\+~:]//gs;
   my @vhd=split(/\.\+/,$in{'disconnect'});

   foreach my $v (@vhd) {
      $v=~s/\s//gs;
      print "Dismount-DiskImage -ImagePath $v<br>";
      print &socket("Dismount-DiskImage -ImagePath $v -AsJob","127.0.0.1");
      sleep(2);
      print "<br>";
   }

   sleep(2);
   $in{'action'}="";
   #exit:
   &reload;

   #&print_array(@vhd);
   #&print_hash(%in);
}

###############################################
#end of my script, do not delete the line below
1;
