###############
sub my_action {
###############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action

 my ($var1, $ant, $type,$d);

 if ($current{'on'}=~/mswin/i) {
   &load_lib('get-spaces.pl');
}  else {
   &mess('Storage Spaces are Windows only');
}

#  &gethash_sys_poolnames;

# header
print "<script language='javascript'>document.getElementById('hl').innerHTML='extend Windows Pool on $in{'member'}\:$current{'on'}'</script>\n";


# 1. edited
if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
if ($in{'answered'}) { &my_add }     # form -> create

# 2. are the unused hds?
if ($disk{'all_unused'} eq "") {
  print" no disks available!";
  return;
}


# 2. get form
####################################################################
# create new pool

print <<EoF;
<b>Howto create a Windows Software Raid</b><br><pre>You can use a Windows Storagepool with Storage Spaces (virtual disks) to manage storage under Windows as an alternative to ZFS.
While not as feature rich as ZFS, it can be good extension for some use cases ex when you need a higher disk performance as ZFS can offer. Windows redundancy on storage pools is not
based on disk redundancy like with traditional Raid but dataslab allocation of Storage Spaces/virtual disks. The space allocation is distributed proportionally according to disk sizes
and wanted redundancy level. In Windows Settings you can optimize a Pool to rebalance data spread over disks.

<b>Usage of disks: (Allocation method in a Raid)</b>
Unknown         The intended usage is not specified.
Auto-Select     This physical disk should only be used for data storage.
Manual-Select   This physical disk should only be used if manually selected by an administrator at the time of virtual disk creation. A manual-select disk is selected using the PhysicalDisksToUse parameter to CreateVirtualDisk.
Hot Spare       This physical disk should be used as a hot spare.
Retired         This physical disk should be retired from use. At a minimum, no new allocations should go to this disk. If the virtual disks that reside on this disk are repaired, the data should be moved to another active physical disk.
Journal         This physical disk should be used as a cache for other devices comprising a virtual disk. It will back a virtual disk s write-back cache, if configured.

<b style='color:red'>Do not select disks you want to use by ZFS for a Windows Storage Pool<br>Check Disk Management. Disks must be empty and not contain a GPT Partition. You can clean disks with diskpart!!!</b></pre>
EoF


# form begin
&ask('begin');

## how many disks
@t=split(/\t/,$disk{'all_unused'});

$t=$win{'allpools'};
$t=~s/p://g;
$t=~s/\t*primordial\t*//i;
$t=~s/\t/,/g;

## name of pool
  &ask('select_pool','Select a Pool',$t,"$in{'select_pool'}");
  &ask('select_usage','Set Disk Usage (Allocation method in a Raid)',"Data/Auto,Manual,Hotspare,Retired,Journal",'');
  &ask('select_media','Set Mediatype',"HDD,SSD,SCM");

  ## checkboxes unused disks
  my $p=&checkboxes("$disk{'all_unused'}","disk","MediaType,Usage,Manufacturer,Model,Size");              # list,hash,addvalues
  &ask('checkbox_hd','Disks (Set mediatype and usage)<br></b>care about minimal disknumbers for wanted redundancy levels',$p)

&ask('end');

print "<script language='javascript'>\$('#hl').html('Expand StoragePool on $in{'member'}\:$current{'on'}')</script>\n";
######################### / form ############################################

} #/ my_action
################



##############################################################################
sub my_add {
################ add disk

   # get info
   #  Get-PhysicalDisk | Select-Object DeviceID, FriendlyName, MediaType, Uniqueid

   # set mediatype manually
   # Set-PhysicalDisk -uniqueid 600144F06DAD1770000066768F3E0009 -mediatype SCM

   my ($i,@w,$n,$what,$pool,$ver,$opt,$opt1,$children,$draid);

   print "after error messages or warnings, check menu pools for real pool state<br>";

   #pool?
   if ($in{'select_pool'} eq "")    { &mess("missing poolname?"); }

   #size only on spaces
   #$in{'value_size'}=~s/\D//g;
   #if ($in{'value_size'} eq "")    { &mess("missing poolsize?"); }

   #get hd-id
   $in{'checkbox_hd'}=~s/[^a-zA-Z0-9\-\_\,\.\+]//gs;        # remove special char from reload
   $in{'checkbox_hd'}=~s/\.\+$//;

   @w = split(/\.\+/,$in{'checkbox_hd'});                   # array of selected disks
   foreach my $w ( @w) {
      $w=~s/\_.*//;
   }                # array of selected disks

   $n=@w;
   if ($n < 1)  { &mess("missing disks"); }

#&print_array(@w);

   # we need a list of uniqueid from physicaldrive0_UniqueId
   # 5000C5002DFAB4EE;50014E6EADFAE1EF;50014E6E58A5BD05

   $n="";
   foreach my $w (@w) {
     $t=$w."_UniqueId";
     $n.=";$disk{$t}";
   }
   $n=~s/^;+//;

   #usage
   # Accepted values:        AutoSelect, ManualSelect, HotSpare, Retired, Journal
   $usage="AutoSelect";
   if ($in{'select_usage'}=~/Manual/i)   {  $usage="ManualSelect"; }
   if ($in{'select_usage'}=~/Spare/i)    {  $usage="HotSpare"; }
   if ($in{'select_usage'}=~/Retired/i)  {  $usage="Retired"; }
   if ($in{'select_usage'}=~/Journal/i)  {  $usage="Journal"; }

# &mess($n);

   #create pool
   ################################################################

   #action
   #######

   my $cmd=<<EoF;
Add-Physicaldisk -StoragePoolFriendlyName $in{'select_pool'} -Usage $usage -PhysicalDisks (Get-PhysicalDisk | \?{"$n".Contains(\$_.uniqueid)}) $in{'value_opt'}
EoF

   $cmd=~s/\n//gs;
#&print_var("$cmd");
   print "$cmd<hr>";
   $i=&exe("$cmd");

   # set mediatype when not specivied
   # Get-StoragePool wpool | Get-PhysicalDisk | ? MediaType -eq "Unspecified" | Set-PhysicalDisk -MediaType SCM

   # usage
   if ($in{'select_usage'} ne "-")    {
        foreach my $w ( @w)   {
            $k=$w."_UniqueId";
            print "Set-PhysicalDisk -uniqueid $disk{$k} -usage $in{'select_usage'}: ";
            print &exe("Set-PhysicalDisk -uniqueid $disk{$k} -usage $in{'select_usage'}")."<br>";
        }
   }

   print "<br>";

   # media
   if ($in{'select_media'} ne "-")    {
          foreach my $w ( @w)   {
            $k=$w."_UniqueId";
            print "Set-PhysicalDisk -uniqueid $disk{$k} -mediatype $in{'select_media'}: ";
            print &exe("Set-PhysicalDisk -uniqueid $disk{$k} -mediatype $in{'select_media'}")."<br>";
        }

   }

   #something wrong?
   if ($i ne "") { print "$i"; }

   # goto create spaces
   print "You can now create Storage Spaces (Virtual Disks)<br>";
   $t=&exe("Get-StoragePool $in{'value_new'} | Get-PhysicalDisk");
   print "<pre>$t</pre>";
   sleep(5);

   $in{'l2'}="";
   $in{'answered'}="";
   &reload;

   exit;

   #################################

}





###############################################
#end of my script, do not delete the line below
1;