###############
sub my_action {
###############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action

 my ($var1, $ant, $type,$d);

 if ($current{'on'}=~/mswin/i) {
   &load_lib('get-spaces.pl');
}  else {
   &mess('Storage Spaces are Windows only');
}

#  &gethash_sys_poolnames;

# header
print "<script language='javascript'>document.getElementById('hl').innerHTML='Define Windows Storage Tiers on $in{'member'}\:$current{'on'}'</script>\n";


# 1. edited
if (($in{'answered'}) && ($in{'action'} eq "tiering")) { &my_tiering }     # form -> add


# 2. get form
####################################################################
# create new pool

# form begin
&ask('begin');

## how many disks
# @t=split(/\t/,$disk{'all_unused'});

my $t=$win{'allpools'};
$t=~s/p://g;
$t=~s/\t*primordial\t*//i;
$t=~s/\t/,/g;

if ($in{'select_pool'} eq "") {  $in{'select_pool'}=$t; $in{'select_pool'}=~s/,.*//; }

## name of pool
  print "<b>Storage Tiering</b><br>Tiers are groups of disks in a Storagepool with a different performance grouped by media type. ";
  print "This allows Windows to place hot data automatically on the fastest Tier and cold data on the slower Tier based <br>on access patterns. ";
  print "You can define up to three Tiers. You cannot remove Tiers once created other than a pool recreate. ";
  print "Check twice for needed disks per Tier for redundancy and available capacity per Tier. ";
  print "Tiering requires fixed provisioning on Storage Spaces. Tiers can only be destroyed with a Pool destroy/recreate<br><br>";

  &ask('select_pool','Enable Storage Tiers on Pool: ',$t,"$in{'select_pool'}");

  &ask('select_tier','Tier stages<br></b><b>',"HDD+SSD,HDD+SCM,HDD+SSD+SCM",'');

  &ask('select_hdd','HDD Tier structure optimized for<br></b>"Real" Parity is set when you create a Storage Space<b>','simple+mirror+parity','');
  &ask('select_ssd','SSD Tier structure optimized for<br></b>"Real" Parity is set when you create a Storage Space<b>','simple+mirror+parity','');
  &ask('select_scm','SCM Tier structure (if available) optimized for<br></b>"Real" Parity is set when you create a Storage Space<b>','simple+mirror+parity','');

  &ask('hidden','action','tiering');
  &ask('end');

  print "<br>Get-StoragePool $in{'select_pool'} | Get-Storagetier<hr>";
  $ant= &exe("Get-StoragePool $in{'select_pool'} | Get-Storagetier");
  print "<pre>$ant<hr></pre><br>";


######################### / form ############################################

} #/ my_action
################



##############################################################################
sub my_tiering {
################ add virtualdisk

   my ($cmd,$r,$t,$is);

   print "<b>Set Tiering stages</b><br>";

   # 1. get current
   $cmd="Get-StoragePool \"$in{'select_pool'}\" | Get-Storagetier";
   $is=&exe($cmd);
   print "<pre>$is</pre><br>";

   # 2. set when not created
   #####
   # hdd
   #####
   if (!($is=~/HDD_Simple_Tier/is))  {

      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName HDD_Simple_Tier -MediaType HDD -ResiliencySettingName Simple";

      print "$cmd<br>";
      $r=&exe($cmd);
   } else {
      print "HDD_Simple_Tier already created<br>";
   }

   if (!($is=~/HDD_Mirror_Tier/is))  {

      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName HDD_Mirror_Tier -MediaType HDD -ResiliencySettingName Mirror";

      print "$cmd<br>";
      $r=&exe($cmd);
    } else {
      print "HDD_Mirror_Tier already created<br>";
    }

    if (!($is=~/HDD_Parity_Tier/is))  {
      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName HDD_Parity_Tier -MediaType HDD  -ResiliencySettingName Parity";

      print "$cmd<br>";
      $r=&exe($cmd);
    } else {
      print "HDD_Parity_Tier already created<br>";
    }

   ######
   # ssd
   ######
   if (!($is=~/SSD_Simple_Tier/is))  {

      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName SSD_Simple_Tier -MediaType SSD -ResiliencySettingName Simple";

      print "$cmd<br>";
      $r=&exe($cmd);
   } else {
      print "SSD_Simple_Tier already created<br>";
   }

   if (!($is=~/SSD_Mirror_Tier/is))  {

      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName SSD_Mirror_Tier -MediaType SSD -ResiliencySettingName Mirror";

      print "$cmd<br>";
      $r=&exe($cmd);
    } else {
      print "SSD_Mirror_Tier already created<br>";
    }

    if (!($is=~/SSD_Parity_Tier/is))  {
      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName SSD_Parity_Tier -MediaType SSD -ResiliencySettingName Parity";

      print "$cmd<br>";
      $r=&exe($cmd);
    } else {
      print "HDD_Parity_Tier already created<br>";
    }

   # scm
   if (!($is=~/SCM_Simple_Tier/is))  {

      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName SCM_Simple_Tier -MediaType SCM -ResiliencySettingName Simple";

      print "$cmd<br>";
      $r=&exe($cmd);
   } else {
      print "SCM_Simple_Tier already created<br>";
   }

   if (!($is=~/SCM_Mirror_Tier/is))  {

      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName SCM_Mirror_Tier -MediaType SCM -ResiliencySettingName Mirror";

      print "$cmd<br>";
      $r=&exe($cmd);
    } else {
      print "SCMMirror_Tier already created<br>";
    }

    if (!($is=~/SCM_Parity_Tier/is))  {
      $cmd="New-StorageTier -StoragePoolFriendlyName \"$in{'select_pool'}\" -FriendlyName SCM_Parity_Tier -MediaType SCM -ResiliencySettingName Parity";

      print "$cmd<br>";
      $r=&exe($cmd);
    } else {
      print "SCM_Parity_Tier already created<br>";
    }



   # net tiering status
   $cmd="Get-StoragePool \"$in{'select_pool'}\" | Get-Storagetier";
   $is=&exe($cmd);
   print "New Tiering state<br><pre>$is</pre><br>";

   &print_hash(%in);



#&print_hash(%in);
   #vd
   $in{'value_new'}=~s/ +//g;
   $in{'value_size'}=~s/\D//g;
   $in{'value_new'}=lc($in{'value_new'});

   if ($in{'select_pool'} eq "")    { &mess("missing poolname?"); }
   if ($in{'value_new'} eq "")      { &mess("missing Stoage Space name?"); }

   # check if vd exists
   $r=&exe("get-virtualdisk | ft FriendlyName");
   if ($r=~/\b$in{'value_new'}\b/is)    { &mess("Storage Space $in{'value_new'} exists, choose another name!"); }

# &mess($n);

   #create vd
   ################################################################
   print "<br><br><b>Storage Space $in{'value_new'}</b><br><br>";

   #action
   #######

   my $size;
   if ($in{'value_size'} eq "") {
      $size=" -UseMaximumSize";
   } else {
      $size=" -Size $in{'value_size'}$in{'select_cap'}"
   }
   my $mt="";
   if ($in{'select_media'}=~/[A-Z]/) {
     $mt=" -MediaType $in{'select_media'}"; }

   my $cmd=<<EoF;
New-Virtualdisk -StoragePoolFriendlyName $in{'select_pool'} -FriendlyName $in{'value_new'}$size$mt -ResiliencySettingName $in{'select_resilency'} -PhysicalDiskRedundancy $in{'select_disk'} -NumberOfDataCopies $in{'select_copies'} $in{'value_opt'}
EoF

   $cmd=~s/\n//gs;
   print "<b>Create Storage Space $in{'value_new'}</b><br>";
   print "$cmd<hr>";
   $i=&exe("$cmd");

   #something wrong?
   if ($i ne "") { print "$i";  sleep(3); }


   ############### init and format
   my $aus=$in{'select_aus'};
   $aus=~s/k//i;
   $aus=1024*$aus;

   my $dl="-AssignDriveLetter";
   if ($in{'select_dl'} ne "auto") {
      $dl="-DriveLetter $in{'select_dl'}";
   }

   my $init="Get-VirtualDisk -FriendlyName $in{'value_new'} | Get-Disk | Initialize-Disk";
   my $formatdev="Get-VirtualDisk -FriendlyName $in{'value_new'} | Get-Disk | New-Partition $dl -UseMaximumSize | Format-Volume -DevDrive -AllocationUnitSize $aus";

   if ($in{'select_fs'}=~/create/i) { $t="NTFS"; } else { $t=$in{'select_fs'}; }     # use default
   my $format="Get-VirtualDisk -FriendlyName $in{'value_new'} | Get-Disk | New-Partition $dl -UseMaximumSize | Format-Volume -FileSystem $t -AllocationUnitSize $aus";
   ##############################

   # create only
   if ($in{'select_fs'}=~/create|initialize/i)  {

          if ($in{'select_fs'} =~/initialize/i)  {
              print "<br><br><b>Initialize Storage Space</b><br>";

              print "$init<hr>";
              $i= &exe("$init");
              print "$i<br>";
          }

          print "<br><b>Partition and format manually ex via Powershell (admin), either devfs or other</b><br>";
          print "$formatdev<br>";
          print "$format";

   } else {

       # initialize space, create partition and format
       # Get-VirtualDisk -FriendlyName SS1 | Get-Disk | Initialize-Disk -Passthru | New-Partition $dl -UseMaximumSize | Format-Volume -FileSystem $in{'select_fs'} -AllocationUnitSize $aus -AsJob

       #dev drive (ReFS)
       # Format-Volume -DriveLetter R -DevDrive

       if ($in{'select_fs'} =~/Dev/)  {

          print "<br><br><b>Initialize Dev Storage Space</b><br>";

          print "$init<hr>";
          $i= &exe("$init");
          print "$i<br>";
          #leep(4);

          print "<br><b>Create Partition and Format</b><br>";       # avoid problems with initialisatio
          print "$formatdev<hr>";
          $t= &exe("start-process powershell -argumentlist \"$formatdev\" -windowstyle hidden");

          print "$t<br>";
          $i.=$t;

       } else {

          print "<br><br><b>Initialize Storage Space</b><br>";

          print "$init<hr>";
          $i= &exe("$init");
          print "$i<br>";

          #sleep(4);
          print "<br><b>Create Partition and Format</b><br>";       # avoid problems with initialisation

          print "$format <hr>";
          $t= &exe("start-process powershell -argumentlist \"$format\" -windowstyle hidden");
          print "$t<br>";
          $i.=$t;

       }

       #print "<br><b>Get-Job (Format)<b><hr>";
       #$r= &exe("Get-Job | grep Format");
       #print "<pre>$r</pre>";

       print "<br><br>Initialising/formatting can last some time until you can access....<br>";
       print "Check result, set driveletter or reformat in Windows Diskmanager<br>";
   }


   #something wrong?
   if ($i ne "") { print "$i";  }

   &log_end;   exit;                 # or
   sleep(3); &reload;

   #################################

}





###############################################
#end of my script, do not delete the line below
1;