#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

print <<EoF;
<pre><b>Windows Storage Pool</b>
A Windows Storage Pool is NOT a diskbased raid !
You simply define which physical disks or virtual harddisks are members.
Think of it like a basket where you can throw in disks (any type, any size).

This has some consequences.
- There is no disk replace or raid rebuild
- Redundancy, Striping or Data tiering is not done on Pool level but on Storage Spaces
- You can define Disk Usage at Pool level like Hotspare or Journal

Tiering
- Tiering means to have groups of disks with a different performance based on media type
- Define in a first step the behaviour of the Tiers in menu Pools > Windows > Pool Config and Tiering
- To play with Tiers, you can use unspecified disks ex iSCSI Targets and assign them a Mediatype when you add them
- For Performance Tiers (SSD,SCM) use Mirror
- Once defined you can remove a tier only with a pool backup/destroy/recreate/restore
- use defrag.exe /C /H /K /G at admin console to check or optimize tiering

- SMB Clustering is done on Virtual Harddisk level.

Maintenance
- Remove bad disk, add a new one.

</pre>
EoF

 print "<script language='javascript'>\$('#hl').html('Storage Pools on $in{'member'}\:$current{'on'}')</script>\n";
 &log_end;

}

###############################################
#end of my script, do not delete the line below
1;
