#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

my ($out,$r,$var,$k,$w,@w,@p,$vd,$n,$i);  # declare all your variables as local or you will get errors

  # menue actions
  ###############

 #Windows pools
 if (!($current{'on'}=~/mswin/i))  {

      &mess('Windows Storage Pools and Storage Spaces is available on Windows only');

 } else {

    #&load_lib('get-spaces.pl');
 }

 print "<b>Windows Storage Pools</b>";
 $w="<b>Pool</b>\t<b>Operational</b>\t<b>Health</b>\t<b>Primordial</b>\t<b>Readonly</b>\t<b>Size</b>\t<b>Alloc</b>\n";

 my @pools=split(/\t/,$win{'allpools'});
 foreach my $pool (@pools) {

        # FriendlyName
        $k="p:$pool\_FriendlyName";
        $w.="$win{$k}\t";

        # OperationalStatus
        $k="p:$pool\_OperationalStatus";
        $w.="$win{$k}\t";

        # HealthStatus
        $k="p:$pool\_HealthStatus";
        $w.="$win{$k}\t";

        # IsPrimordial
        $k="p:$pool\_IsPrimordial";
        $w.="$win{$k}\t";

        # IsReadOnly
        $k="p:$pool\_IsReadOnly";
        $w.="$win{$k}\t";

        # Size
        $k="p:$pool\_Size";
        $w.="$win{$k}\t";

        # AllocatedSize
        $k="p:$pool\_AllocatedSize";
        $w.="$win{$k}\t";

        $w.="\n";
 }

 print &list2table($w);

 ##########################################################
 print "<br><b>Windows Storage Spaces (Virtual Disks)</b>";
 ##########################################################

    # all possible values
    # $w="FriendlyName,Usage,NameFormat,OperationalStatus,HealthStatus,ProvisioningType,AllocationUnitSize,MediaType,ParityLayout,Access,UniqueIdFormat,DetachedReason,WriteCacheSize,FaultDomainAwareness,ColumnIsolation,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,UniqueId,AllocatedSize,FootprintOnPool,Interleave,IsDeduplicationEnabled,IsEnclosureAware,IsManualAttach,IsSnapshot,IsTiered,LogicalSectorSize,MaxIoBandwidth,MaxIops,MinimumLogicalDataCopies,Name,NumberOfAvailableCopies,NumberOfColumns,NumberOfDataCopies,NumberOfGroups,OtherOperationalStatusDescription,OtherUsageDescription,PhysicalDiskRedundancy,PhysicalSectorSize,ReadCacheSize,RequestNoSinglePointOfFailure,ResiliencySettingName,Size,TrackValidData,UniqueIdFormatDescription,WriteCacheReserveSize,PSComputerName";

    # or basics
    #$w="FriendlyName\tResiliencySettingName\tFaultDomainRedundancy\tOperationalStatus\tHealthStatus\tSize\tFootprintOnPool\tStorageEfficiency";

    #or individual
    $w="FriendlyName,Status,Health,Provisioning,Interleave,AllocationUnitSize,Allocated,MediaType,IsTiered,DataCopies,DiskRedundancy,Resiliency,Size,Footprint,OnPhysicalDisks";

 @w=split(/,/,$w);

 my @vds=split(/\t/,$win{'allvds'});
 $vd="$w\n";                            # headers

 if (@vds==0) { $vd.="-none-"; }

 $n=0;
 foreach my $vds (@vds) {


        # FriendlyName
        $k="v:$vds\_FriendlyName";
        $vd.="$win{$k}\t";

        # OperationalStatus
        $k="v:$vds\_OperationalStatus";
        $vd.="$win{$k}\t";

        # HealthStatus
        $k="v:$vds\_HealthStatus";
        $vd.="$win{$k}\t";

        # ProvisioningType
        $k="v:$vds\_ProvisioningType";
        $vd.="$win{$k}\t";

        # Interleave
        $k="v:$vds\_Interleave";
        $vd.="$win{$k}\t";

        # AllocationUnitSize
        $k="v:$vds\_AllocationUnitSize";
        $vd.="$win{$k}\t";

        # AllocatedSize
        $k="v:$vds\_AllocatedSize";
        $vd.="$win{$k}\t";

        # MediaType
        $k="v:$vds\_MediaType";
        $vd.="$win{$k}\t";

        # IsTiered
        $k="v:$vds\_IsTiered";
        $vd.="$win{$k}\t";

        # NumberOfDataCopies
        $k="v:$vds\_NumberOfDataCopies";
        $vd.="$win{$k}\t";

        # PhysicalDiskRedundancy
        $k="v:$vds\_PhysicalDiskRedundancy";
        $vd.="$win{$k}\t";

        # ResiliencySettingName
        $k="v:$vds\_ResiliencySettingName";
        $vd.="$win{$k}\t";

        # Size
        $k="v:$vds\_Size";
        $vd.="$win{$k}\t";

        # FootprintOnPool
        $k="v:$vds\_FootprintOnPool";
        $t=&b_convert($win{$k},'b','s');
        $vd.="$t\t";

        # OnDisks
        $k="v:$vds\_OnDisks";
        $t=$win{$k}; $t=~s/,/;/g;
        $vd.="$t\t";

        $vd.="\n";

 }

 $vd=~s/,/\t/gs;
 print &list2table("$vd",'','bold');

 # header
 print "<script language='javascript'>\$('#hl').html('Storage Spaces on $in{'member'}\:$current{'on'}')</script>\n";

 log_end;

 if ($log_on) {  print "<br>".&print_hash(%win); }

 exit;


} #/ my_action




###############################################
#end of my script, do not delete the line below
1;
