###############
sub my_action {
###############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action

 my ($var1, $ant, $type,$d);

 if ($current{'on'}=~/mswin/i) {
   &load_lib('get-spaces.pl');
}  else {
   &mess('Storage Spaces are Windows only');
}

#  &gethash_sys_poolnames;

# header
print "<script language='javascript'>document.getElementById('hl').innerHTML='Create a Windows Storage Tier Virtual Disk on $in{'member'}\:$current{'on'}'</script>\n";


# 1. edited
if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
if ($in{'answered'}) { &my_add }     # form -> add


# 2. get form
####################################################################
# create new pool

# form begin
&ask('begin');

## how many disks
@t=split(/\t/,$disk{'all_unused'});

$t=$win{'allpools'};
$t=~s/p://g;
$t=~s/\t*primordial\t*//i;
$t=~s/\t/,/g;

## name of pool
  print "<b>Storage Tiering</b><br>Tiers are groups of disks in a Storagepool with a different performance grouped by media type. ";
  print "This allows Windows to place hot data automatically on the fastest Tier and cold data on the slower Tier based <br>on access patterns. ";
  print "You can split the space over Tiers. You cannot change that later. Autotiering is once a day or optimize manually via defrag.exe /C /H /K /G";
  print "Check twice for needed disks per Tier for redundancy and available capacity per Tier. Tiered Spaces require fixed provisioning<br><br>";

  &ask('select_pool','Create a Storage Tier (Tiered Virtual Disk) on Pool: ',$t,"$in{'select_pool'}");
  &ask('value_new','New Tiered Storage Space Name<b>',"$in{'value_new'}",'w100m32');

  &ask('select_rt','Resilency Type of Tiered Storage Space<br></b>Mirror requires 2 Disks, 3way mirror 5 disks, Parity 3 disks and <br>dual parity 7 disks<b>',"Simple,Mirror,Parity",'Mirror');

  #&ask('select_dc','Data copiesbr></b> ex 2 = 2= mirror/Raid5, 2=Raid 6<b>',"1,2,3",'1');
  # or redundant setting?
  &ask('select_dr','Physical disk redundancy<br></b>Disks allowed to fail, ex 0=none, 1=Mirror/Raid5, 2=Raid 6<b>',"0,1,2",'1');

  &ask('select_wc','Write cache on fastest Tier<b>',"1GB,2GB,4GB,8GB,16GB,32GB",'4GB');

  &ask('value_size1','Space Size Slow Tier<br></b>Standard Tier (HDD) ex 20TB<b>',"",'w37m7');

  &ask('value_size2','Space Size SSD Tier<br></b>Fast Tier ex 1.5TB<b>',"",'w37m7');

  &ask('value_size3','Space Size SCM Tier<br></b>Ultrafast Tier ex 500GB (if available)<b>',"-",'w37m7');


  &ask('select_fs','Filesystem</b><br>ReFS needs OS support, <br>Dev is ReFS on a normal Win11 with AUS 4K-64K<b>',"NTFS,ReFS,Dev(ReFS),create only,create and initialize, show Powershell cmd only",'');
  &ask('select_dl','Driveletter',"auto,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z",'');
  &ask('select_aus','Allocation Unit Size</b><br></b>Default=4k, larger values are faster but not as space efficient <br>NTFS:  4-2048K, ReFS 4-64K<b>',"4K,8K,16K,32K,64K,128K,256K,512K,1024K,2048K",'64K');

  &ask('value_opt','Optional settings for New-Virtualdisk ex </b><br>-NumberOfColumns 3<b>',"$in{'value_opt'}",'w300');


&ask('end');
print "On errors, mainly due too large size values in Tiers, destroy Space and recreate.";


######################### / form ############################################

} #/ my_action
################



##############################################################################
sub my_add {
################ add virtualdisk

  # -NumberOfDataCopies
  # Specifies the number of data copies to create. Specify 2 to create a two-way mirror, or 3 to specify a three-way mirror or for dual parity.

  #-PhysicalDiskRedundancy
  #Specifies the physical disk redundancy value to use during the creation of a virtual disk.
  #This value represents how many failed physical disks the virtual disk can tolerate without data loss.

  #For two-way mirror spaces, the virtual disk can tolerate 1 failed physical disk without data loss.
  #For three-way mirror spaces, the virtual disk can tolerate 2 failed physical disks without data loss.
  #For single-parity spaces, the virtual disk can tolerate 1 failed physical disk without data loss.
  #For dual-parity spaces the virtual disk can tolerate 2 failed physical disks without data loss.

  #-ResiliencySettingName
  #Specifies the resiliency setting, or storage layout, to use for the virtual disk. Acceptable values vary by storage subsystem.
  #
  #Allowed values for the Windows Storage subsystem are: Simple, Mirror, or Parity.
  # By default, when you specify Mirror, Storage Spaces creates a two-way mirror, and when you specify Parity, Storage Spaces creates a single-parity space.
  #
  # To create a three-way mirror space, specify 3 for the NumberofDataCopies parameter or 2 for the PhysicalDiskRedundancy parameter.
  # To create a dual-parity space, specify 2 for the PhysicalDiskRedundancy parameter and Fixed provisioning for the ProvisioningType parameter.

  # Create a mirror space with storage tiers
  # $SSD = Get-StorageTier -FriendlyName *SSD*
  # $HDD = Get-StorageTier -FriendlyName *HDD*
  # Get-StoragePool CompanyData | New-VirtualDisk -FriendlyName "UserData01" -ResiliencySettingName "Mirror" -StorageTiers $SSD, $HDD -StorageTierSizes 8GB, 32GB

  # https://www.dell.com/support/manuals/de-de/storage-md1400-dsms/dsms_bpg_pub-v2/storage-tiers
  # New-VirtualDisk -FriendlyName <vdName> -StoragePoolFriendlyName <poolName> -ProvisioningType Fixed -ResiliencySettingName <Simple| Mirror| Parity> -PhysicalDiskRedundancy <1|2> -StorageTiers <ssdTierObject, hddTierObject>  -StorageTierSizes <ssdTierSize , hddTierSize>

  # chatgpt
  # Get-StoragePool pool | New-VirtualDisk -FriendlyName "UserData01" -ResiliencySettingName "Mirror" -WriteCacheSize 2GB -ProvisioningType Fixed -StorageTiers (Get-StorageTier -FriendlyName SSD_Tier), (Get-StorageTier -FriendlyName HDD_Tier) -StorageTierSizes 2GB, 5GB

  # combine dell and chatgpt
  # Get-StoragePool pool | New-VirtualDisk -FriendlyName "UserData01" -WriteCacheSize 2GB -ProvisioningType Fixed -ResiliencySettingName <Simple| Mirror| Parity> -PhysicalDiskRedundancy <1|2> -StorageTiers (Get-StorageTier -FriendlyName SSD_Tier), (Get-StorageTier -FriendlyName HDD_Tier) -StorageTierSizes 2GB, 5GB

   my ($i,@w,$n,$what,$pool,$ver,$opt,$opt1,$children,$r);

   print "<b>After error messages or warnings, <br>check menu disk manaagement and pools</b><br>";

#&print_hash(%in);
   #vd
   $in{'value_new'}=~s/ +//g;
   $in{'value_new'}=lc($in{'value_new'});

   if ($in{'select_pool'} eq "")    { &mess("missing poolname?"); }
   if ($in{'value_new'} eq "")      { &mess("missing Stoage Space name?"); }

   $in{'value_size1'}=~s/[^0-9KMGTB]//g;
   $in{'value_size2'}=~s/[^0-9KMGTB]//g;
   $in{'value_size3'}=~s/[^0-9KMGTB\-]//g;


   if (!($in{'value_size1'}=~/\d+[KMGT]B/)) {  &mess("HDD Tier size must be a number + KB, MB, GB or TB ex 20TB");}

   if (!($in{'value_size2'}=~/\d+[KMGT]B/)) {  &mess("SSD Tier size must be a number + KB, MB, GB or TB ex 2TB");}


   if ($in{'value_size3'} ne "-" ) {
        if (!($in{'value_size3'}=~/\d+[KMGT]B/)) {  &mess("SCM Tier size must be a number + KB, MB, GB or TB ex 20GB");}
   }

   # check if vd exists
   $r=&exe("get-virtualdisk | ft FriendlyName");
   if ($r=~/\b$in{'value_new'}\b/is)    { &mess("Storage Space $in{'value_new'} exists, choose another name!"); }

   # &mess($n);

   #Simple
   if (($in{'select_rt'} ne "0") && ($in{'select_rt'} eq "Simple"))   { $in{'select_dr'}=0; }

   #create vd
   ################################################################
   print "<br><br><b>Storage Space $in{'value_new'}</b><br><br>";

   #action
   #######

   my $pdr="";   # physical disk redundancy
   if ($in{'select_dr'} > 0) { $pdr=" -PhysicalDiskRedundancy $in{'select_dr'} "; }

   #tiers scm, ssd, hdd
   my $tiers="";
   my $sizes="";

   #scm
   if ($in{'value_size3'} ne "-" ) {
      $tiers="(Get-StorageTier -FriendlyName SCM_Tier), ";                  # optional scm
      $sizes="$in{'value_size3'},";
   }

   #ssd always
   $tiers.="(Get-StorageTier -FriendlyName SSD_Tier), ";
   $sizes.="$in{'value_size2'},";

   #hdd always
   if ($in{'select_rt'} eq "Parity" ) {
       $tiers.="(Get-StorageTier -FriendlyName HDD_Parity_Tier)";
   } else {
       $tiers.="(Get-StorageTier -FriendlyName HDD_Tier)";
   }
   $sizes.="$in{'value_size1'}";

   my $cmd=<<EoF;
Get-StoragePool $in{'select_pool'} | New-VirtualDisk -FriendlyName "$in{'value_new'}" -WriteCacheSize $in{'select_wc'} -ProvisioningType Fixed -ResiliencySettingName $in{'select_rt'}$pdr$in{'value_opt'} -StorageTiers $tiers -StorageTierSizes $sizes
EoF

   $cmd=~s/\n//gs;
   print "<b>Create Storage Space $in{'value_new'}</b><br>";
   print "$cmd<hr>";
   if (!($in{'select_fs'} =~/Powershell/))    {
      $i=&exe("$cmd");

      #something wrong?
      if ($i ne "") { print "$i";  sleep(3); }
   }

   ############### init and format
   my $aus=$in{'select_aus'};
   $aus=~s/k//i;
   $aus=1024*$aus;

   my $dl="-AssignDriveLetter";
   if ($in{'select_dl'} ne "auto") {
      $dl="-DriveLetter $in{'select_dl'}";
   }

   my $init="Get-VirtualDisk -FriendlyName $in{'value_new'} | Get-Disk | Initialize-Disk";
   my $formatdev="Get-VirtualDisk -FriendlyName $in{'value_new'} | Get-Disk | New-Partition $dl -UseMaximumSize | Format-Volume -DevDrive -AllocationUnitSize $aus";

   if ($in{'select_fs'}=~/create/i) { $t="NTFS"; } else { $t=$in{'select_fs'}; }     # use default
   my $format="Get-VirtualDisk -FriendlyName $in{'value_new'} | Get-Disk | New-Partition $dl -UseMaximumSize | Format-Volume -FileSystem $t -AllocationUnitSize $aus -FileSystemLabel $in{'value_new'}";
   ##############################

   # create only
   if ($in{'select_fs'}=~/create|initialize/i)  {

          if ($in{'select_fs'} =~/initialize/i)  {
              print "<br><br><b>Initialize Storage Space</b><br>";

              print "$init<hr>";
              $i= &exe("$init");
              print "$i<br>";
          }

          print "<br><b>Partition and format manually ex via Powershell (admin), either devfs or other</b><br>";
          print "$formatdev<br>";
          print "$format";

   } else {

       # initialize space, create partition and format
       # Get-VirtualDisk -FriendlyName SS1 | Get-Disk | Initialize-Disk -Passthru | New-Partition $dl -UseMaximumSize | Format-Volume -FileSystem $in{'select_fs'} -AllocationUnitSize $aus -AsJob

       #dev drive (ReFS)
       # Format-Volume -DriveLetter R -DevDrive

       if ($in{'select_fs'} =~/Dev/)  {

          print "<br><br><b>Initialize Dev Storage Space</b><br>";

          print "$init<hr>";
          if (!($in{'select_fs'}=~/Powershell/))    {
            $i= &exe("$init");
            print "$i<br>";
          }
          #leep(4);

          print "<br><b>Create Partition and Format</b><br>";       # avoid problems with initialisatio
          print "$formatdev<hr>";

          if (!($in{'select_fs'} =~/Powershell/))    {
            $t= &exe("start-process powershell -argumentlist \"$formatdev\" -windowstyle hidden");

            print "$t<br>";
            $i.=$t;
          }

       } else {

          print "<br><br><b>Initialize Storage Space</b><br>";

          print "$init<hr>";
          if (!($in{'select_fs'} =~/Powershell/))    {
            $i= &exe("$init");
            print "$i<br>";
          }

          #sleep(4);
          print "<br><b>Create Partition and Format</b><br>";       # avoid problems with initialisation

          print "$format <hr>";
          if (!($in{'select_fs'} =~/Powershell/))    {
            $t= &exe("start-process powershell -argumentlist \"$format\" -windowstyle hidden");
            print "$t<br>";
            $i.=$t;
          }

       }

       #print "<br><b>Get-Job (Format)<b><hr>";
       #$r= &exe("Get-Job | grep Format");
       #print "<pre>$r</pre>";

       print "<br><br>Initialising/formatting can last some time until you can access....<br>";
       print "Check result, optionally set driveletter or reformat in Windows Diskmanager<br>";
   }


   #something wrong?
   if ($i ne "") { print "$i";  }

   &log_end;
   exit;                 # or
   sleep(3); &reload;

   #################################

}





###############################################
#end of my script, do not delete the line below
1;