###############
sub my_action {
###############
my ($w,@p);

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action


 if ($current{'on'}=~/mswin/i) {
   #&load_lib('get-spaces.pl');                         # preload
}  else {
   &mess('Storage Spaces are Windows only');
}



#overview: get-psdrive -psprovider "filesystem"
$w="Name\tUsed (GB)\tFree (GB)\tProvider\tRoot\tUniqueId\tType\tFileSystem\tFilesystemType";
my $r=&exe("get-psdrive -psprovider 'filesystem'");

#Name           Used (GB)     Free (GB) Provider      Root                                Curr                                                                                         entL                                                                                         oca                                                                                         ion
#----           ---------     --------- --------      ----                                ----
#C                  52,68         42,50 FileSystem    C:\                                 ...t
#D                   5,17          0,00 FileSystem    D:\
#S                   0,00          1,00 FileSystem    S:\

print "<b>Filesystem Overview</b> (get-psdrive -psprovider 'filesystem')";

my $vol="$w\n";
my @vols=split(/\n/,$r);

foreach my $v (@vols) {
     if (!($v=~/\\/)) { next; }
     $v=~s/\\.*/\\/;
     @p=split(/ +/,$v);

     #name, used,free,provider,root
     $vol.="$p[0]\t$p[1]\t$p[2]\t$p[3]\t$p[4]\t";

     # id
     $t="dl:$p[0]\_UniqueId";
     $vol.="$win{$t}\t";

     # drivetype
     $t="dl:$p[0]\_DriveType";
     $vol.="$win{$t}\t";

     # fs
     $t="dl:$p[0]\_FileSystem";
     $vol.="$win{$t}\t";

     # fstype
     $t="dl:$p[0]\_FileSystemType";
     $vol.="$win{$t}\t";

     $vol.="\n";
}

print &list2table("$vol",'','bold');


#######################################
print "<br><b>Windows Storage Volumes</b>";
######################################


#############
#all possible
#UniqueId,OperationalStatus,HealthStatus,DriveType,FileSystemType,DedupMode,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,AllocationUnitSize,DriveLetter,FileSystem,FileSystemLabel,Path,Size,SizeRemaining,PSComputerName'

$w="UniqueId,Drive,Label,DriveType,FileSystem,FileSystemType,AllocationUnitSize,Dedup,Health,Status,Size,SizeRemaining";

$vol="$w\n"; $vol=~s/,/\t/g;

 @vols=split(/\t/,$win{'allvols'});
 foreach my $v (@vols) {

        # UniqueId
        $k="l:$v\_UniqueId";
        $vol.="$win{$k}\t";

        # Driveletters
        $k="l:$v\_DriveLetter";
        $vol.="$win{$k}\t";

        # FileSystemLabel
        $k="l:$v\_FileSystemLabel";
        $vol.="$win{$k}\t";

        # DriveType
        $k="l:$v\_DriveType";
        $vol.="$win{$k}\t";

        # FileSystem
        $k="l:$v\_FileSystem";
        $vol.="$win{$k}\t";

        # FileSystemType
        $k="l:$v\_FileSystemType";
        $vol.="$win{$k}\t";

        # AllocationUnitSize
        $k="l:$v\_AllocationUnitSize";
        $vol.="$win{$k}\t";

        # DedupMode
        $k="l:$v\_DedupMode";
        $vol.="$win{$k}\t";

        # HealthStatus
        $k="l:$v\_HealthStatus";
        $vol.="$win{$k}\t";

        # OperationalStatus
        $k="l:$v\_OperationalStatus";
        $vol.="$win{$k}\t";

        # Size
        $k="l:$v\_Size";
        $vol.="$win{$k}\t";

        # SizeRemaining"
        $k="l:$v\_SizeRemaining";
        $vol.="$win{$k}\t";

        $vol.="\n";
 }

print &list2table("$vol",'','bold');

#/Volumes

#######################################
print "<br><b>Windows Storage Partitions</b>";
######################################

#all possible
#'UniqueId,OperationalStatus,Type,DiskPath,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,AccessPaths,DiskId,DiskNumber,DriveLetter,GptType,Guid,IsActive,IsBoot,IsDAX,IsHidden,IsOffline,IsReadOnly,IsShadowCopy,IsSystem,MbrType,NoDefaultDriveLetter,Offset,PartitionNumber,Size,TransitionState,PSComputerName'

$w="UniqueId,Nr,Type,DriveLetter,Offset,IsActive,IsBoot,IsSystem,IsDAX,IsHidden,IsOffline,IsReadOnly,IsShadowCopy,Size";

my $part="$w\n"; $part=~s/,/\t/g;

 my @parts=split(/\t/,$win{'allpart'});
 foreach my $v (@parts) {

        # UniqueId
        $k="r:$v\_UniqueId";
        $part.="$win{$k}\t";

        # PartitionNumber
        $k="r:$v\_PartitionNumber";
        $part.="$win{$k}\t";

        # Type
        $k="r:$v\_Type";
        $part.="$win{$k}\t";

        # DriveLetter
        $k="r:$v\_DriveLetter";
        $part.="$win{$k}\t";

        # Offset
        $k="r:$v\_Offset";
        $part.="$win{$k}\t";

        # IsActive
        $k="r:$v\_IsActive";
        $part.="$win{$k}\t";

        # IsBoot
        $k="r:$v\_IsBoot";
        $part.="$win{$k}\t";

        # IsSystem
        $k="r:$v\_IsSystem";
        $part.="$win{$k}\t";

        # IsDAX
        $k="r:$v\_IsDAX";
        $part.="$win{$k}\t";

        # IsHidden
        $k="r:$v\_IsHidden";
        $part.="$win{$k}\t";

        # IsOffline
        $k="r:$v\_IsOffline";
        $part.="$win{$k}\t";

        # IsReadOnly
        $k="r:$v\_IsReadOnly";
        $part.="$win{$k}\t";

        # IsShadowCopy
        $k="r:$v\_IsShadowCopy";
        $part.="$win{$k}\t";


        # Size
        $k="r:$v\_Size";
        $part.="$win{$k}\t";

        $part.="\n";
 }

print &list2table("$part",'','bold');

#/part



print "<script language='javascript'>\$('#hl').html('Volumes and Partitions on $in{'member'}\:$current{'on'}')</script>\n";

&log_end;
if ($log_on) {  print "<br>".&print_hash(%win); }
exit;





######################### / form ############################################

} #/ my_action
################


###############################################
#end of my script, do not delete the line below
1;