#!/usr/bin/perl
#
# license reminder
# send an alert 21,14,7 days prior end then daily

###############################
# part 1 - same for all reports
###############################

use strict;
use vars qw(%zfs %sys @par @t $t $f %r $os $id $alertlist $alertlistf $alertlog $statlog $alertsend $statsend $alertmess $info $alert $message $text $subject $binpath $lpath $spath);

use Fcntl qw(:flock); # filelocking
$|=1;                 # keine Pufferung, no buffering

require "/xampp/web-gui/data/wwwroot/cgi-bin/admin-wlib.pl";

#process report and return results
require "/xampp/web-gui/data/menues/_lib/scripts/reports/report.lib";                                          # load my_report, set message, text and alertmess
print "message_begin=$message"."message_end\nalert_begin=$alertmess"."alert_end\nstatus_begin=$text"."status_end\n";   # end


###################
# end common part 1
###################


###########################
# part 2, modify per report

###############   executed via require report.lib
sub my_report {
###############
        # license reminder
        my ($p,$r);
        my $host=`hostname`;

        $t="";
        $text="";
        $alertmess="";

        if (-f "/xampp/web-gui/_log/appliance.log") {
                 $t=&my_read("/xampp/web-gui/_log/appliance.log");
                  @t=();
                  @t=split(/\n/,$t);

                  foreach my $v (@t) {
                          if ($v=~/eval/)             { next; }
                          if (!($v=~/\d+\.\d+\.\d+/)) { next; }
                          $p=$v;
                          $p=~s/::.*//;

                          $v=~s/:.*//;
                          $v=~s/.*\- //;                  # keep data
                          $r=&date2diff($sys{'date'},$v); # 2val - 1val

                          #&mess($r);
                          $text.="$p\n";

                          if (($r<=21) && ($r>0)) {
                             $text.="$p ($r days left)\n";
                             if ($r<7)  {                              # last seven days: every day
                                $alertmess.="$p ($r days left)\n";
                             } else {
                                if (($r eq "21") || ($r eq "14"))  {   # once
                                   $alertmess.="$p ($r days left)\n";
                                }
                             }
                          }
                  }
                  #&mess($alert);

                  if ($alertmess ne "") {
                     $subject .=" License Reminder";
                     $alert.="1";
                     $alertmess.="Reminder: one or more extensions are due to expire on $host\: \n$alertmess";
                  }  else {
                     $alert.="0";
                  }
                  #$text="Reminder: Extensions on $host\: \n$text";

        }

        # cli debug?
        # print $text;
        # $alert="1"; $subject="test";
        if ($alertmess eq "") { $subject="ok"; }

        return ($subject);          # use it ex for email subject
}

# eof
1;