#
#task-lib.pl
#(c) napp-it 2014-2024
# win


 ################
 sub task_jobproc {
 ###############

    print __LINE__." task_jobproc skript: $0\n";
    my $script=$0;   # path/job-xx.pl

    # to identify if a job is running (is started via proc-perl ex _csperl_jobid)
    # so we check first if this process was already called via cs_perl_id (opt~/p/)

    # this job was started via id process
    if ($opt=~/p/) {

         print "\n".__LINE__." task_jobproc, process was started via _csperl_$id.exe\n";

    } else {

          # create jobrelated perl
         $t="$action\_$id p$opt";               # ex p123
         $p="_csperl_$id.exe";
         copy("/xampp/perl/bin/perl.exe", "/xampp/perl/bin/$p");
         sleep(1);
          print "\n".__LINE__." restart Perl processes with _csperl_$id.exe $script $t\n";        # start with opt p
         system ("/xampp/perl/bin/$p  $script $t");
         sleep(1);
         unlink("/xampp/perl/bin/$p");
         exit;
    }

    return;
 }

  ##############
 sub task_norestart {
 #############

    my $id=$_[0];
    #
    # a job should not restart while running
    # a running replication job is indicated by a single jobrelated _csperl_id process
    # if "this" call iis second, do not start

    my $t=&socket("tasklist","127.0.0.1");
    my $p=&grep("$t","csperl_$id");
    print __LINE__." prozesses for id: $id<br>\n";
    my @p=split(/\n/,$p);

    print __LINE__." <pre>task_norestart id $id\: \n$p\n</pre>\n";


    $t=@p;
    if ($t>1)          {  return ("running ($t)"); }

    # debug
    print &print_my_par;
    return('ok');
}

################
sub task_exec {
#################                # start manually from joblist

use IO::Socket::INET;

       my $par=$_[0];            # job-scrub
       my $id= $_[1];            # jobid
       my $do= $_[2];            # do: run,cancel,delete

       #debug
       #print "start taskexec.pl 29 $par\n";

      #script
      my $n=1;
      my $t="$wpath/data/menues/_lib/windows/scripts/$par\.pl";
      if (-f "$t") { $n="0"; }

      if ($n) {
        &log("taskexec.pl 96: error, no jobfile");
        print __LINE__." no jobscript: $t\n";
        return;
      }


      # exec, max 2 parameter, todo
      my $running=&task_norestart($id);

      &log("taskexec.pl 87: parameter $par $id running=$running","tal");
      if ($running ne "ok") {
         print __LINE__." process state -> $running";
         sleep(2);
         $in{'action'}='';
#exit;
         &reload;
      }

      #REM 'start napp-it background server service'
      # create jobrelated perl

      my $p="_csperl_$id.exe";
      copy("/xampp/perl/bin/perl.exe", "/xampp/perl/bin/$p");
      sleep(1);

      $t=~s/\//\\/g;
      print "powershell start-process -WorkingDirectory $wpath -filepath C:\\xampp\\perl\\bin\\$p -argumentlist \"$t\",\"$do\_$id\",\"p\" -WindowStyle minimized\n";
      sleep(2);
      `powershell start-process  -WorkingDirectory $wpath -filepath C:\\xampp\\perl\\bin\\$p -argumentlist \"$t\",\"$do\_$id\",\"p\" -WindowStyle minimized`;            # jobs are local
      sleep(3);
      unlink("/xampp/perl/bin/$p");

      my $tl=&socket("tasklist","127.0.0.1");
      $t=&grep("$tl","$p");
      print __LINE__."<pre>$t</pre>";
      sleep(3);
      #exit;

          #$r=`uname -a`;
          #if ($r=~/^Linux/i) {
          #  `perl /var/web-gui/data/scripts/$f $t[0] $t[1] >/dev/null 2>&1`;             # avoids shell spamming in Linux when deleted
          #} else {
          #  exec("perl","/var/web-gui/data/scripts/$f","\'$t[0]\'","\'$t[1]\'");
          #}
         #
}



######################                   # main script get all or single par
sub task_read_jobpar {                   # par -> %current
######################

    # .job file is obsolet from 0.9+
    # .par is used and optionally created from jobfile instead (script or /_my/script)

    # read jobparameter from jobfile to %current
    # if job is given: only this job
    # otherwise all or for a special jobtype (based on l2)

    my $id=$_[0];                        # optional jobnr
    my $ver=$_[1];
    my (@v,$v,$k,$p,@m,@d);
    @m=('','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

    my $f="$wpath/_log/jobs/";  # jobfile

    #debug
    # print "task_read_jobpar 16: dir $f\n";

#&mess($f);
my @files=&task_get_dir("$f","","task-lib 12");

    # step1 update .job -> .par from 0.9+
    # old: id~level2~level3~text1~opt1~text2~opt2~month~day~hour~min~id~status~last.job

    my @n;
    foreach my $t (@files) {
       if ($t=~/\.job$/) {

            # add timetable to par
            @v=();
            @v=split(/\~/,$t);

            @t=();
            $v=&task_read_array_t("$f$t");        # read .job to @t
            if ($v eq "0") { next; }

            # push info from filename
            @n=();
            push(@n,"job=$v[1]\n");
            push(@n,"month=$v[7]\n");
            push(@n,"day=$v[8]\n");
            push(@n,"hour=$v[9]\n");
            push(@n,"min=$v[10]\n");
            push(@n,"status=$v[12]\n");

            $v[13]=~s/\.job$//;
            push(@n,"last=$v[13]\n");

            #add values from .job
            foreach my $v (@t) {
                    if ($v=~/id\=|month\=|day\=|hour\=|min\=/) { next; }      # id only in filename, others from filename
                    chomp($v);

                    # update repli
                    if ($v[1] eq "replicate") {
                            if ($v=~/^text1=/) {                          # text1=192.168.88.3-59814
                                $p="transport=nc\n";                      push(@n,$p);       # transport
                                $v=~s/test1=//;
                                $p="$v"; $p=~s/.*\-//; $p="port=$p\n";    push(@n,$p);       # port
                                $p="$v"; $p=~s/\-.*//; $p="hostip=$p\n";  push(@n,$p);       # hostip
                            }
                            if ($v=~/^host|^source|^destination|^dest_sharename|^send_dedup|^rec_option|^send_option|^pv_limit/) {                          # host=oi3
                                push(@n,"$v\n");
                            }
                            if ($v=~/^dest_shareguest=\w+/) {            # dest_sharguest
                                push(@n,"dest_shareguest=yes\n");
                            }
                            if ($v=~/^send_rec=\-R/) {                   # dest_sharguest
                                push(@n,"recursiv=yes\n");
                            }
                            if ($v=~/^send_dedup=-D/) {                 # dest_sharguest
                                push(@n,"send_dedup=yes\n");
                            }
                            if ($v=~/^esxi/) {                          # esxi_ip
                                push(@n,"$v\n");
                            }

                    }
                    # update scrub
                    if ($v[1] eq "scrub") {
                       if ($v=~/^pool=/) {                               # host=oi3
                                push(@n,"$v\n");
                       }
                    }
                    # update snap
                    if ($v[1] eq "snap") {
                       if ($v=~/^pool|^keep/) {
                                push(@n,"$v\n");
                       }
                       if ($v=~/^delnull=yes/) {
                               push(@n,"delzero=yes\n");
                       }
                       if ($v=~/^esxi/) {                                  # esxi_ip
                                push(@n,"$v\n");
                       }
                    }
                    # update other
                    if ($v[1] eq "other") {
                       if ($v=~/^action|^condition|^noerr|^err|^text1/) {
                                push(@n,"$v\n");
                       }
                    }
                    # update email
                    if ($v[1] eq "email") {
                       if ($v=~/^server|^to|^from|^user|^pw|^trigger/) {
                                push(@n,"$v\n");
                       }
                    }
                    # update report
                    if ($v[1] eq "report") {
                       if ($v=~/^server|^to|^from|^user|^pw|^trigger/) {
                                push(@n,"$v\n");
                       }
                    }

                    # update backup
                    if ($v[1] eq "backup") {
                       if ($v=~/_|fs|pool/) {
                                push(@n,"$v\n");
                       }
                    }
            }

            unlink("$f$t");                       # del id.job
            $t=~s/~.*/.par/;                      # remove all but id  and add .par
            @t=();
            @t=sort(@n);
 #&print_array(@n);
            &task_write_array_t("$f$t");          # write par
            #
       }
    }

    # step 2: get all par
    my ($p,@p,$i);
    foreach my $t (@files) {

       #.pl (old): delete from napp-it < 0.9
       if ($t=~/\.pl$/)  {  unlink("$f$t");  next; }       #del .pl, obsolet (use job-script)

       if (!($t=~/\.par$/))  {   next; }                   # only .par

       # single id~
       if ( (!($t=~/^$id/)) && ($id > 0)) {   next; }      # only single job

       $i=$t;
       $i=~s/\..*$//;                       # jobid

       $k="$i\_state";
       $current{$k}="";                       # default: no state   (running etc)

       #joblist
       if (!($current{'joblist'}=~/$i/)) {
           $current{'joblist'}.="$i,";      # commalist
       }

       # jobvalues from .par files
       @t=();
       &task_read_array_t("$f$t");          # read to @t

       # par to %current
       foreach $v (@t)  {                  #all parameters

          if (!($v=~/\=/))      { next; }  # ip=1234
          @p=();
          $v=~s/\s+$//;
          $v=~s/=/_=_/;         # first
          @p=split(/\_\=\_/,$v);               # allow ip=123 -0 b=3


          # do not use state from file
          if ($p[0] eq "state")  { next; }
          if ($p[0] eq "allpar") { next; }

          $k="$i"."_$p[0]";                 #type ex: 1234_job -> scrub
          $current{$k}=$p[1];

      }


      $k="$i"."_month"; if ($current{$k} eq "") { $current{$k}="every"; }
      $k="$i"."_day";   if ($current{$k} eq "") { $current{$k}="every"; }
      $k="$i"."_hour";  if ($current{$k} eq "") { $current{$k}="0"; }
      $k="$i"."_min";   if ($current{$k} eq "") { $current{$k}="0"; }

      $k="$i"."_status";
      if ($current{$k} eq "") {
          $current{$k}="manual";
      }

      #replication set to manual
#      if ($ver ne "") {
#              $k="$i"."_job";
#              if ( ($current{$k}=~/repli/) && (!($ver=~/c|r/)) )  {
#                    $k="$i"."_status";
#                    if ($current{$k} ne "manual") {
#                         $current{$k}="manual";
#                         &task_update_par($i);
#                    }
#                    $k="$i"."_month";   $current{$k}="manual";
#              }
#      }


      # get last run > current('id_last') from if.last
        @t=();
        $t=~s/\.par$/.last/;

        if (-f "$f$t") {
             &task_read_array_t("$f$t");                    # read to @t


             @t=reverse(@t);

             $k="$i"."_lastcall";                            # jobid: $i
             $current{$k}="n.a.";

             if ($t[0]=~/^\d+\.\d+\.\d+\.\d+\.\d+\./) {     # 2015.04.16.08.00.01

                  @d=();
                  @d=split(/\./,$t[0]);
                  $d[1]=$m[$d[1]];                          # 01 -> Jan
                  $current{$k}="$d[2].$d[1]&nbsp;$d[3]:$d[4]";

                  $k="$i"."_last";
                  $current{$k}="$d[2].$d[1]&nbsp;$d[3]:$d[4]";      # show lastcall. not new on some jobs

             }

             # debug
# &print_hash(%current);

        }
 }

 &task_getstate;
 $current{'joblist'}=~s/,$//;

 #debug
 #&print_hash(%current);

}

###### debug
sub print_my_par {
#################
     my ($k,$v,$t);
     #my $id=$_[0];
     $t="job id $id\n";

     #print par
     while (($k,$v) = each %job) {
            $t.= "job $k\=$v\n";
     }
     return ($t);
}


########### log detailed info for last job (klick on Date of last exec)
sub my_log_last {
##########
   &task_gettime;
   my $t=$_[0];
   $t.=" $_[1]";             # like log_id

   my @p0=caller(0);
   my @p1=caller(1); # parent:  package, filename, line, subroutine, hasargs, wantarray, evaltext, is_require, hints, hitmask ex $p1[3] l$p1[2]
   my @p2=caller(2);
   my @p3=caller(3);
   my @p4=caller(4);

   ###################################
   # calling line: $p1[2]
   print "$p1[2] $t\n";      # console
   ###################################

                  my $l="$p0[3] line $p0[2]";             $l=~s/\/.*zfsos\// /; $l=~s/\/.*scripts\// /;
   if ($p1[2] > 0) { $l.="<br> <- $p1[3] line $p1[2]"; }  $l=~s/\/.*zfsos\// /; $l=~s/\/.*scripts\// /;
   if ($p2[2] > 0) { $l.="<br> <- $p2[3] line $p2[2]"; }  $l=~s/\/.*zfsos\// /; $l=~s/\/.*scripts\// /;
   if ($p3[2] > 0) { $l.="<br> <- $p3[3] line $p3[2]"; }  $l=~s/\/.*zfsos\// /; $l=~s/\/.*scripts\// /;
   if ($p4[2] > 0) { $l.="<br> <- $p4[3] line $p4[2]"; }  $l=~s/\/.*zfsos\// /; $l=~s/\/.*scripts\// /;
   $l=~s/main::/\&/gs;
   $l=~s/br> +/br> /g;
   $l=~s/\s+/ /g;

   $l=~s/\n/<br>/g;
   $t=~s/\n/<br>/gs;


   my $log="$wpath/_log/jobs/$id.last";
   open (PF, ">>$log");
     flock(PF, LOCK_EX);
     print PF "$current{'timestamp'}\t$l\t$t\n";
   close (PF);

   #print __LINE__." $id.last: \n$t\n";   # opt
}


########### write log  to general jobs.log
sub my_log_jobs {
###############
 my (@v,$v,$n,$l,$f1,$f2,@data,$t);
 my $mess=$_[0];

 #$l="ok";
 #if ($mess=~/^error/)  { $l="error"; }

 my @p0=caller(0);
 my @p1=caller(1); # parent:  package, filename, line, subroutine, hasargs, wantarray, evaltext, is_require, hints, hitmask ex $p1[3] l$p1[2]
 my @p2=caller(2);
 my @p3=caller(3);
 my @p4=caller(4);

 # calling line: $p1[2]
  $mess=~s/\n/ /gs;

  #stage 1: log general jobs.log
  ###########################

    my $log="$wpath/_log/jobs/jobs.log";
    my $lock="$wpath/_log/jobs/jobs.lock";
    open (X,"<$lock");
          flock(X, LOCK_EX);
          #
          open (F,"<$log");
                flock(F, LOCK_EX);
                @data=<F>;
          close (F);

          #unshift   $l=ok/error
          unshift(@data,"$l; replication $id; time: $current{'timestamp'} line: $p1[2];$mess\n");

          if (@data > 50) {
                     $t=@data-50;
                     splice(@data,50,$t);
          }

         $t=join("",@data);
         open (PF, ">$log");
            flock(PF, LOCK_EX);
            print PF "$t";
         close (PF);
   close (X);
}


###################
sub update_lastrun {
####################
      # update last run in $id.par

      &task_gettime;
      my $log="$wpath/_log/jobs/$id.par";
      open (F,"<$log");
            flock(F, LOCK_EX);
            @data=<F>;
      close (F);
      foreach my $t (@data) {
             if ($t=~/^last=/)   {
                $t="last=$current{'logtime'}\n";
                print "2500 update $t\n";
             }
      }
      $t=join("",@data);

      open (PF, ">$log");
        flock(PF, LOCK_EX);
        print PF "$t";
      close (PF);
      &my_log_last("1522 update id.par: last=$current{'logtime'}");

}


##############  log to id.log
sub my_log_id {
#############

my @p1=caller(0); # this:
my @p2=caller(1); # parent:  package, filename, line, subroutine, hasargs, wantarray, evaltext, is_require, hints, hitmask
# calling line: $p1[2]

my $err=$_[0];
my $data="line $p1[2] $_[1]";
$data=~s/ +/ /g;

my @data;
&task_gettime;


  my $log="$wpath/_log/jobs/$id.log";
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$err time: $current{'timestamp'} line $p1[2]; $data\n");

  if (@data > 300) {
             $t=@data-300;
             splice(@data,300,$t);                 # delete from 50+
  }

  my $t=join("",@data);
  open (PF, ">$log");
     flock(PF, LOCK_EX);
     print PF "$t";
  close (PF);

}

###################
sub task_getstate {
###################   get state (ex running)
my (@r,$r,$k);

return; # obsolete?

if ($sys{'Readsocket'} eq "1") { print "tasklib  140\n"; }
     # get requests ex /tmp/nappit/job-scrub_1350378156.request
     @r=&task_get_dir("$wpath/tmp",".request","task_getstate 61");

     foreach $r (@r) {
         if (!($r=~/job\-.*\.request$/)) { next; }
         $r=~s/\.request//;
         $r=~s/.*\_//;       # keep jobid
         if ($r=~/^\d+$/) {
            $k="$r\_state";
            $current{$k}="request";                              # set state to request
         }
     }

     # get local running like job-scrub_1350378156.pl

    # $r=`ps axw | grep job-`;

#debug
#$r=~s/\n/<br>/gs;  print "<!--wscontent-->task socket $sys{'Readsocket'} $r";  exit;

     @r=();
     @r=split(/\n/,$r);

     foreach $r (@r) {
           chomp($r);

           if ($r=~/grep/) { next; }
           $r=~s/.*\_//;                       # ..run_id
           $r=~s/ .*//;                        # remove opt second parameter
           $r=~s/\D//g;# keep jobid

          # print "#### task-lib 153 running=$r\n";
           $t="$r\_job";
           $t=$current{$t};

           if (($r=~/^\d+$/) && ($t ne "")) {                   # valid job
              $k="$r\_state";
              $current{$k}="running";                           # set state to running

              if (-f "/tmp/nappit/$r.cancel")   {
                     $current{$k} = "run/cancel";
              }
           }


     }
#&print_hash(%current);
}



sub task_gettime {
###########
 my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 my @m=('','jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec');
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 $current{'logtime'}="$mday\.$m[$mon]\_$hour\_$min";
 $current{'timestamp'}="$year\.$mon\.$mday\.$hour\.$min\.$sec";

}

#############
sub task_get_dir    { # &task_get_dir("dir","Muster","Zeilennr") return array
############
 my @par = @_;
 my $tmp;
 if ($par[2] eq "") { $par[2]="\.\*"; } #beliebig

 my $file;
 my @liste;
 local (*F);
 if ($par[0] eq "") { print"(lib-561 read_dir: $par[2]) Programmfehler: Es wurde kein Verzeichnis angegeben (ref $_[3])\n"; exit; }
 if (!(-d $par[0])) { print"(lib-1356 read_dir: $par[0]) Programmfehler: Kein Directory (ref $_[2])\n"; exit; }

 opendir(F, $par[0]);
 while(defined($file=readdir F)) {
        next if (($file =~/^\.$/) || ($file =~/^\.\.$/));
        $tmp="$par[0]\/$file";
        if (-d $tmp) { $file="$file\/"; }        # $file/ falls directory
        if ($par[1]=~/\./) {        #.xxx
                if ($file=~/$par[1]$/) {  push (@liste,$file); }
        } else {
                push (@liste,$file);
        }
 }
 closedir(F);
 return(@liste);
}


#####################
sub task_read_array_t {
####################
  my $f=$_[0];
  @t=();
  if (-f $f) {
     open (F,"<$f");
          flock(F, LOCK_EX);
          @t=<F>;                    # read to public @t
     close (F);
     return(1);
  }  else {
     $t[0]="error: in task_read_array- file $f not found";
     return(0);
  }
}

###################
sub task_update_par {
###################  write new par-file from %current
     &task_gettime;        # update logtime

     my $id=$_[0];

     if (!($id=~/^\d+$/)) { print "\n###tasklib update 237: no id\n"; return(0); }
     my ($k,$v,$t);
     @t=();
     while (($k,$v) = each %current) {
            if (!($k=~/^$id\_/))    { next; }

            #do not write state like running
            if ($k=~/^state|allpar|lastrun/)       { next; }

            $t=$k; $t=~s/^\d+\_//;           # 12345_job -> job
            push (@t,"$t\=$v");
     }
     #&print_array(@t);
     &task_write_array_t("$wpath/_log/jobs/$id.par");


}

######################        # updae job.par
sub task_write_array_t {
####################          # write public @t
  my $f=$_[0];                # filename
  my $a=$_[1];                # append if a

  if ($a=~/a/) {
    open (F,">>$f");
  } else {
    open (F,">$f");
  }
  flock(F, LOCK_EX);
  foreach my $t (@t) {
    if (!($t=~/\w/)) { next; }
    chomp($t);
    print F "$t\n";
  }
  close (F);
}



### end ###
1;